'use strict';
var a00 = (function (_global) {
  if (_global.a00) {
    return _global.a00;
  }
  var _now = _global.Date.now ? _global.Date.now : function () {
    return new _global.Date().getTime();
  };
  var xhr, http, a;
  var token = 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE1ODM4MzA2MTg5NjAzNjAwLCJ1c2VySWQiOiIxNyIsInByb2ZpbGluZ1J1bklkIjoiNWU2NzU2NWE2NzAxZTgwMDExYzIzNmUzIiwiaWF0IjoxNTgzODMwNjE4fQ.IElkPVIJmpvtIljriz770ACFsHARdLijjmgJth6Ua1g', path = '/p/profiling-data-point/2107a04479f9f1832a9fd5bb06e5eb716967aeee/5e67565a6701e80011c236e3', protocol = 'http', port = '8068', host = 'localhost', jscramblerVersion = 6.3;
  var reqErrorCounter = 0, shouldSend = false, setTimeoutRegistered = false, stopSendingData = false;
  var contentTypeKey = 'Content-Type', contentType = 'application/json', authorizationKey = 'Authorization', authorization = 'Bearer ' + token, jscramblerVersionKey = 'jscramblerVersion', method = 'POST';
  var headers = {};
  headers[contentTypeKey] = contentType;
  headers[authorizationKey] = authorization;
  headers[jscramblerVersionKey] = jscramblerVersion;
  var postOptions = {
    host: host,
    port: port,
    path: path,
    method: method,
    headers: headers
  };
  _global.XMLHttpRequest && (xhr = new _global.XMLHttpRequest()) || typeof require === typeof _global.Date && (a = require) && (http = a(protocol));
  function sendInfo(globalObject) {
    function clearErrorCounter() {
      reqErrorCounter = 0;
    }
    function errorHandler() {
      if (++reqErrorCounter >= 3) {
        stopSendingData = true;
        console.error('Limit of errored requests reached, stopping request service.');
      } else {
        registerSendTimer();
      }
    }
    function handleStatusCode(statusCode, statusMsg) {
      switch (statusCode) {
        case 200:
          clearErrorCounter();
          shouldSend = false;
          break;
        case 403:
          stopSendingData = true;
          break;
        case 424:
          stopSendingData = true;
          console.error('Make sure to "Start Profiling" on the web application before running the instrumented app.');
          break;
        default:
          errorHandler();
      }
    }
    function httpResponseHandler(response) {
      var statusCode = response.statusCode;
      var statusMessage = response.statusMessage;
      handleStatusCode(statusCode, statusMessage);
    }
    function compatibilityReqHandler() {
      if (xhr.readyState === 4) {
        handleStatusCode(xhr.status, xhr.responseText);
      }
    }
    function sendRequest(data) {
      data.sessionMetadata['timestamp'] = _now();
      if (xhr) {
        xhr.onreadystatechange = compatibilityReqHandler;
        xhr.open(method, protocol + '://' + host + ':' + port + path, true);
        xhr.setRequestHeader(authorizationKey, authorization);
        xhr.setRequestHeader(contentTypeKey, contentType);
        xhr.setRequestHeader(jscramblerVersionKey, jscramblerVersion);
        xhr.send(JSON.stringify(data));
      } else if (http) {
        var req = http.request(postOptions, httpResponseHandler);
        req.write(JSON.stringify(data));
        req.end();
        req.on('error', function (err) {
          var errorMsg = 'Failed to contact profiling service! Error message: ' + err.message;
          errorHandler();
        });
      } else {
        console.log('Error: Supported network request API interfaces (xhr, http) are not available in this context! Please contact the support.');
      }
    }
    ;
    if (!stopSendingData) {
      sendRequest(reportObj);
    }
  }
  ;
  var reportObj = {
    sessionMetadata: {
      sessionId: _now(),
      platform: _global.process && _global.process.platform ? _global.process.platform : _global.navigator && _global.navigator.platform,
      userAgent: _global.navigator && _global.navigator.userAgent,
      location: _global.location && _global.location.href,
      nodeVersion: _global.process && _global.process.version,
      product: _global.navigator && _global.navigator.product || (_global.android ? 'NativeScript/android' : undefined)
    },
    data: {}
  };
  var lastRecord = {
    s: 0
  };
  function registerSendTimer() {
    setTimeoutRegistered = true;
    setTimeout(function () {
      setTimeoutRegistered = false;
      return sendInfo(_global);
    }, 2500);
  }
  function record(name, type, stopFn, fn) {
    if (type === -1) {
      reportObj.data[name][2] += 1;
      return fn;
    }
    var t = _now();
    shouldSend = true;
    if (reportObj.data[name] === undefined) {
      reportObj.data[name] = [0, 0, 0];
    }
    if (shouldSend && !setTimeoutRegistered && !stopSendingData) {
      registerSendTimer();
    }
    if (type === 1) {
      reportObj.data[name][0] += 1;
    }
    if (lastRecord.s === 0) {
      lastRecord = {
        f: name,
        s: type,
        t: t
      };
      return fn;
    }
    reportObj.data[lastRecord.f][1] += t - lastRecord.t;
    lastRecord = {
      f: name,
      s: type,
      t: _now()
    };
    return fn;
  }
  ;
  ;
  _global.a00 = record;
  return _global.a00;
})(global);
a00(28, 1);
a00(28, 2, a00(28, 0), Object.defineProperty(exports, "__esModule", {
  value: true
}));
exports.default = signedParams;
var _lodash = require('lodash.clone');
var _lodash2 = a00(28, 2, a00(28, 0), _interopRequireDefault(_lodash));
var _crypto = require('crypto');
var _crypto2 = a00(28, 2, a00(28, 0), _interopRequireDefault(_crypto));
var _lodash3 = require('lodash.defaults');
var _lodash4 = a00(28, 2, a00(28, 0), _interopRequireDefault(_lodash3));
var _lodash5 = require('lodash.keys');
var _lodash6 = a00(28, 2, a00(28, 0), _interopRequireDefault(_lodash5));
function _interopRequireDefault(obj) {
  try {
    a00(29, 1);
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  } finally {
    a00(29, 0);
  }
}
var debug = ! !process.env.DEBUG;
function signedParams(method, path, host, keys) {
  try {
    a00(30, 1);
    var params = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
    params = a00(30, 2, a00(30, 0), (0, _lodash4.default)((0, _lodash2.default)(params), {
      access_key: keys.accessKey,
      timestamp: a00(30, 2, a00(30, 0), new Date().toISOString())
    }));
    params.signature = a00(30, 2, a00(30, 0), generateHmacSignature(method, path, host, keys, params));
    return params;
  } finally {
    a00(30, 0);
  }
}
function generateHmacSignature(method, path, host, keys, params) {
  try {
    a00(31, 1);
    var paramsCopy = a00(31, 2, a00(31, 0), (0, _lodash2.default)(params));
    var signatureData = a00(31, 2, a00(31, 0), method.toUpperCase()) + ';' + a00(31, 2, a00(31, 0), host.toLowerCase()) + ';' + path + ';' + a00(31, 2, a00(31, 0), buildSortedQuery(paramsCopy));
    debug && a00(31, 2, a00(31, 0), console.log('Signature data: ' + signatureData));
    var hmac = a00(31, 2, a00(31, 0), _crypto2.default.createHmac('sha256', keys.secretKey.toUpperCase()));
    a00(31, 2, a00(31, 0), hmac.update(signatureData));
    return a00(31, 2, a00(31, 0), hmac.digest('base64'));
  } finally {
    a00(31, 0);
  }
}
function buildSortedQuery(params) {
  try {
    a00(32, 1);
    var _keys = a00(32, 2, a00(32, 0), a00(32, 2, a00(32, 0), (0, _lodash6.default)(params)).sort());
    var query = '';
    for (var i = 0, l = _keys.length; i < l; i++) {
      a00(32, -1);
      query += a00(32, 2, a00(32, 0), encodeURIComponent(_keys[i])) + '=' + a00(32, 2, a00(32, 0), encodeURIComponent(params[_keys[i]])) + '&';
    }
    query = a00(32, 2, a00(32, 0), a00(32, 2, a00(32, 0), a00(32, 2, a00(32, 0), a00(32, 2, a00(32, 0), query.replace(/\*/g, '%2A')).replace(/[!'()]/g, escape)).replace(/%7E/g, '~')).replace(/\+/g, '%20'));
    return a00(32, 2, a00(32, 0), query.substring(0, query.length - 1));
  } finally {
    a00(32, 0);
  }
}
a00(28, 0);