'use strict';
var a00 = (function (_global) {
  if (_global.a00) {
    return _global.a00;
  }
  var _now = _global.Date.now ? _global.Date.now : function () {
    return new _global.Date().getTime();
  };
  var xhr, http, a;
  var token = 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE1ODM4MzA2MTg5NjAzNjAwLCJ1c2VySWQiOiIxNyIsInByb2ZpbGluZ1J1bklkIjoiNWU2NzU2NWE2NzAxZTgwMDExYzIzNmUzIiwiaWF0IjoxNTgzODMwNjE4fQ.IElkPVIJmpvtIljriz770ACFsHARdLijjmgJth6Ua1g', path = '/p/profiling-data-point/2107a04479f9f1832a9fd5bb06e5eb716967aeee/5e67565a6701e80011c236e3', protocol = 'http', port = '8068', host = 'localhost', jscramblerVersion = 6.3;
  var reqErrorCounter = 0, shouldSend = false, setTimeoutRegistered = false, stopSendingData = false;
  var contentTypeKey = 'Content-Type', contentType = 'application/json', authorizationKey = 'Authorization', authorization = 'Bearer ' + token, jscramblerVersionKey = 'jscramblerVersion', method = 'POST';
  var headers = {};
  headers[contentTypeKey] = contentType;
  headers[authorizationKey] = authorization;
  headers[jscramblerVersionKey] = jscramblerVersion;
  var postOptions = {
    host: host,
    port: port,
    path: path,
    method: method,
    headers: headers
  };
  _global.XMLHttpRequest && (xhr = new _global.XMLHttpRequest()) || typeof require === typeof _global.Date && (a = require) && (http = a(protocol));
  function sendInfo(globalObject) {
    function clearErrorCounter() {
      reqErrorCounter = 0;
    }
    function errorHandler() {
      if (++reqErrorCounter >= 3) {
        stopSendingData = true;
        console.error('Limit of errored requests reached, stopping request service.');
      } else {
        registerSendTimer();
      }
    }
    function handleStatusCode(statusCode, statusMsg) {
      switch (statusCode) {
        case 200:
          clearErrorCounter();
          shouldSend = false;
          break;
        case 403:
          stopSendingData = true;
          break;
        case 424:
          stopSendingData = true;
          console.error('Make sure to "Start Profiling" on the web application before running the instrumented app.');
          break;
        default:
          errorHandler();
      }
    }
    function httpResponseHandler(response) {
      var statusCode = response.statusCode;
      var statusMessage = response.statusMessage;
      handleStatusCode(statusCode, statusMessage);
    }
    function compatibilityReqHandler() {
      if (xhr.readyState === 4) {
        handleStatusCode(xhr.status, xhr.responseText);
      }
    }
    function sendRequest(data) {
      data.sessionMetadata['timestamp'] = _now();
      if (xhr) {
        xhr.onreadystatechange = compatibilityReqHandler;
        xhr.open(method, protocol + '://' + host + ':' + port + path, true);
        xhr.setRequestHeader(authorizationKey, authorization);
        xhr.setRequestHeader(contentTypeKey, contentType);
        xhr.setRequestHeader(jscramblerVersionKey, jscramblerVersion);
        xhr.send(JSON.stringify(data));
      } else if (http) {
        var req = http.request(postOptions, httpResponseHandler);
        req.write(JSON.stringify(data));
        req.end();
        req.on('error', function (err) {
          var errorMsg = 'Failed to contact profiling service! Error message: ' + err.message;
          errorHandler();
        });
      } else {
        console.log('Error: Supported network request API interfaces (xhr, http) are not available in this context! Please contact the support.');
      }
    }
    ;
    if (!stopSendingData) {
      sendRequest(reportObj);
    }
  }
  ;
  var reportObj = {
    sessionMetadata: {
      sessionId: _now(),
      platform: _global.process && _global.process.platform ? _global.process.platform : _global.navigator && _global.navigator.platform,
      userAgent: _global.navigator && _global.navigator.userAgent,
      location: _global.location && _global.location.href,
      nodeVersion: _global.process && _global.process.version,
      product: _global.navigator && _global.navigator.product || (_global.android ? 'NativeScript/android' : undefined)
    },
    data: {}
  };
  var lastRecord = {
    s: 0
  };
  function registerSendTimer() {
    setTimeoutRegistered = true;
    setTimeout(function () {
      setTimeoutRegistered = false;
      return sendInfo(_global);
    }, 2500);
  }
  function record(name, type, stopFn, fn) {
    if (type === -1) {
      reportObj.data[name][2] += 1;
      return fn;
    }
    var t = _now();
    shouldSend = true;
    if (reportObj.data[name] === undefined) {
      reportObj.data[name] = [0, 0, 0];
    }
    if (shouldSend && !setTimeoutRegistered && !stopSendingData) {
      registerSendTimer();
    }
    if (type === 1) {
      reportObj.data[name][0] += 1;
    }
    if (lastRecord.s === 0) {
      lastRecord = {
        f: name,
        s: type,
        t: t
      };
      return fn;
    }
    reportObj.data[lastRecord.f][1] += t - lastRecord.t;
    lastRecord = {
      f: name,
      s: type,
      t: _now()
    };
    return fn;
  }
  ;
  ;
  _global.a00 = record;
  return _global.a00;
})((function () {
  var f = 2;
  for (; f !== 9;) {
    switch (f) {
      case 1:
        return globalThis;
        break;
      case 2:
        f = typeof globalThis === '\u006f\x62\x6a\x65\u0063\u0074' ? 1 : 5;
        break;
      case 5:
        var _global;
        try {
          var w = 2;
          for (; w !== 4;) {
            switch (w) {
              case 2:
                Object['\u0064\u0065\x66\x69\u006e\u0065\x50\u0072\x6f\u0070\u0065\x72\x74\x79'](Object['\u0070\x72\u006f\x74\u006f\u0074\x79\x70\x65'], '\x5f\u006c\x64\x45\x43', {
                  '\x67\x65\x74': function () {
                    var t = 2;
                    for (; t !== 1;) {
                      switch (t) {
                        case 2:
                          return this;
                          break;
                      }
                    }
                  },
                  '\x63\x6f\x6e\x66\x69\x67\x75\x72\x61\x62\x6c\x65': true
                });
                _global = _ldEC;
                w = 5;
                break;
              case 5:
                delete Object['\x70\x72\x6f\x74\u006f\u0074\u0079\x70\x65']['\u005f\x6c\u0064\u0045\x43'];
                w = 4;
                break;
            }
          }
        } catch (e) {
          _global = window;
        }
        return _global;
        break;
    }
  }
})());
a00(272, 1);
a00(272, 2, a00(272, 0), Object.defineProperty(exports, "__esModule", {
  value: true
}));
exports.getApplication = getApplication;
exports.getApplicationSource = getApplicationSource;
exports.getApplicationProtections = getApplicationProtections;
exports.getApplicationProtectionsCount = getApplicationProtectionsCount;
exports.getTemplates = getTemplates;
exports.getApplications = getApplications;
exports.getProtection = getProtection;
var getApplicationDefaultFragments = '\n  _id,\n  name,\n  createdAt,\n  sources {\n    _id,\n    filename,\n    extension\n  }\n';
function getApplication(applicationId) {
  try {
    a00(273, 1);
    var fragments = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : getApplicationDefaultFragments;
    var params = arguments[2];
    return {
      query: '\n      query getApplication ($applicationId: String!, $protectionsVersion: String, $protectionsLimit: Int) {\n        application(_id: $applicationId, protectionsVersion: $protectionsVersion, protectionsLimit: $protectionsLimit) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: a00(273, 2, a00(273, 0), JSON.stringify(Object.assign({
        applicationId: applicationId
      }, params)))
    };
  } finally {
    a00(273, 0);
  }
}
var getApplicationSourceDefaultFragments = '\n  _id,\n  filename,\n  extension\n';
function getApplicationSource(sourceId) {
  try {
    a00(274, 1);
    var fragments = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : getApplicationSourceDefaultFragments;
    var limits = arguments[2];
    return {
      query: '\n      query getApplicationSource ($sourceId: String!, $contentLimit: Int, $transformedLimit: Int) {\n        applicationSource(_id: $sourceId, contentLimit: $contentLimit, transformedLimit: $transformedLimit) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: a00(274, 2, a00(274, 0), JSON.stringify(Object.assign({
        sourceId: sourceId
      }, limits)))
    };
  } finally {
    a00(274, 0);
  }
}
var getApplicationProtectionsDefaultFragments = '\n  _id,\n  sources,\n  parameters,\n  finishedAt,\n  randomizationSeed\n';
function getApplicationProtections(applicationId, params) {
  try {
    a00(275, 1);
    var fragments = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : getApplicationProtectionsDefaultFragments;
    return {
      query: '\n      query getApplicationProtections ($applicationId: String!, $sort: String, $order: String, $limit: Int, $page: Int) {\n        applicationProtections(_id: $applicationId, sort: $sort, order: $order, limit: $limit, page: $page) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: a00(275, 2, a00(275, 0), JSON.stringify(Object.assign({
        applicationId: applicationId
      }, params)))
    };
  } finally {
    a00(275, 0);
  }
}
var getApplicationProtectionsCountDefaultFragments = '\n  count\n';
function getApplicationProtectionsCount(applicationId) {
  try {
    a00(276, 1);
    var fragments = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : getApplicationProtectionsCountDefaultFragments;
    return {
      query: '\n      query getApplicationProtectionsCount ($applicationId: String!) {\n        applicationProtectionsCount(_id: $applicationId) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: a00(276, 2, a00(276, 0), JSON.stringify({
        applicationId: applicationId
      }))
    };
  } finally {
    a00(276, 0);
  }
}
var getTemplatesDefaultFragments = '\n  _id,\n  parameters\n';
function getTemplates() {
  try {
    a00(277, 1);
    var fragments = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : getTemplatesDefaultFragments;
    return {
      query: '\n      query getTemplates {\n        templates {\n          ' + fragments + '\n        }\n      }\n    ',
      params: '{}'
    };
  } finally {
    a00(277, 0);
  }
}
var getApplicationsDefaultFragments = '\n  _id,\n  name,\n  protections,\n  parameters\n';
function getApplications() {
  try {
    a00(278, 1);
    var fragments = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : getApplicationsDefaultFragments;
    var params = arguments[1];
    return {
      query: '\n      query getApplications($protectionsVersion:String, $protectionsLimit: Int) {\n        applications(protectionsVersion: $protectionsVersion, protectionsLimit: $protectionsLimit) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: a00(278, 2, a00(278, 0), JSON.stringify(Object.assign({}, params)))
    };
  } finally {
    a00(278, 0);
  }
}
var getProtectionDefaultFragments = {
  application: '\n    name\n  ',
  applicationProtection: '\n    _id,\n    state,\n    bail,\n    deprecations {\n      type,\n      entity\n    },\n    errorMessage,\n    sources {\n      filename,\n      errorMessages {\n        message,\n        line,\n        column,\n        fatal\n      }\n    }\n  '
};
function getProtection(applicationId, protectionId) {
  try {
    a00(279, 1);
    var fragments = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : getProtectionDefaultFragments;
    return {
      query: '\n      query getProtection ($applicationId: String!, $protectionId: String!) {\n        application (_id: $applicationId) {\n          ' + fragments.application + '\n        }\n        applicationProtection (_id: $protectionId) {\n          ' + fragments.applicationProtection + '\n        }\n      }\n    ',
      params: a00(279, 2, a00(279, 0), JSON.stringify({
        applicationId: applicationId,
        protectionId: protectionId
      }))
    };
  } finally {
    a00(279, 0);
  }
}
a00(272, 0);