'use strict';
var a00 = (function (_global) {
  if (_global.a00) {
    return _global.a00;
  }
  var _now = _global.Date.now ? _global.Date.now : function () {
    return new _global.Date().getTime();
  };
  var xhr, http, a;
  var token = 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE1ODM4MzA2MTg5NjAzNjAwLCJ1c2VySWQiOiIxNyIsInByb2ZpbGluZ1J1bklkIjoiNWU2NzU2NWE2NzAxZTgwMDExYzIzNmUzIiwiaWF0IjoxNTgzODMwNjE4fQ.IElkPVIJmpvtIljriz770ACFsHARdLijjmgJth6Ua1g', path = '/p/profiling-data-point/2107a04479f9f1832a9fd5bb06e5eb716967aeee/5e67565a6701e80011c236e3', protocol = 'http', port = '8068', host = 'localhost', jscramblerVersion = 6.3;
  var reqErrorCounter = 0, shouldSend = false, setTimeoutRegistered = false, stopSendingData = false;
  var contentTypeKey = 'Content-Type', contentType = 'application/json', authorizationKey = 'Authorization', authorization = 'Bearer ' + token, jscramblerVersionKey = 'jscramblerVersion', method = 'POST';
  var headers = {};
  headers[contentTypeKey] = contentType;
  headers[authorizationKey] = authorization;
  headers[jscramblerVersionKey] = jscramblerVersion;
  var postOptions = {
    host: host,
    port: port,
    path: path,
    method: method,
    headers: headers
  };
  _global.XMLHttpRequest && (xhr = new _global.XMLHttpRequest()) || typeof require === typeof _global.Date && (a = require) && (http = a(protocol));
  function sendInfo(globalObject) {
    function clearErrorCounter() {
      reqErrorCounter = 0;
    }
    function errorHandler() {
      if (++reqErrorCounter >= 3) {
        stopSendingData = true;
        console.error('Limit of errored requests reached, stopping request service.');
      } else {
        registerSendTimer();
      }
    }
    function handleStatusCode(statusCode, statusMsg) {
      switch (statusCode) {
        case 200:
          clearErrorCounter();
          shouldSend = false;
          break;
        case 403:
          stopSendingData = true;
          break;
        case 424:
          stopSendingData = true;
          console.error('Make sure to "Start Profiling" on the web application before running the instrumented app.');
          break;
        default:
          errorHandler();
      }
    }
    function httpResponseHandler(response) {
      var statusCode = response.statusCode;
      var statusMessage = response.statusMessage;
      handleStatusCode(statusCode, statusMessage);
    }
    function compatibilityReqHandler() {
      if (xhr.readyState === 4) {
        handleStatusCode(xhr.status, xhr.responseText);
      }
    }
    function sendRequest(data) {
      data.sessionMetadata['timestamp'] = _now();
      if (xhr) {
        xhr.onreadystatechange = compatibilityReqHandler;
        xhr.open(method, protocol + '://' + host + ':' + port + path, true);
        xhr.setRequestHeader(authorizationKey, authorization);
        xhr.setRequestHeader(contentTypeKey, contentType);
        xhr.setRequestHeader(jscramblerVersionKey, jscramblerVersion);
        xhr.send(JSON.stringify(data));
      } else if (http) {
        var req = http.request(postOptions, httpResponseHandler);
        req.write(JSON.stringify(data));
        req.end();
        req.on('error', function (err) {
          var errorMsg = 'Failed to contact profiling service! Error message: ' + err.message;
          errorHandler();
        });
      } else {
        console.log('Error: Supported network request API interfaces (xhr, http) are not available in this context! Please contact the support.');
      }
    }
    ;
    if (!stopSendingData) {
      sendRequest(reportObj);
    }
  }
  ;
  var reportObj = {
    sessionMetadata: {
      sessionId: _now(),
      platform: _global.process && _global.process.platform ? _global.process.platform : _global.navigator && _global.navigator.platform,
      userAgent: _global.navigator && _global.navigator.userAgent,
      location: _global.location && _global.location.href,
      nodeVersion: _global.process && _global.process.version,
      product: _global.navigator && _global.navigator.product || (_global.android ? 'NativeScript/android' : undefined)
    },
    data: {}
  };
  var lastRecord = {
    s: 0
  };
  function registerSendTimer() {
    setTimeoutRegistered = true;
    setTimeout(function () {
      setTimeoutRegistered = false;
      return sendInfo(_global);
    }, 2500);
  }
  function record(name, type, stopFn, fn) {
    if (type === -1) {
      reportObj.data[name][2] += 1;
      return fn;
    }
    var t = _now();
    shouldSend = true;
    if (reportObj.data[name] === undefined) {
      reportObj.data[name] = [0, 0, 0];
    }
    if (shouldSend && !setTimeoutRegistered && !stopSendingData) {
      registerSendTimer();
    }
    if (type === 1) {
      reportObj.data[name][0] += 1;
    }
    if (lastRecord.s === 0) {
      lastRecord = {
        f: name,
        s: type,
        t: t
      };
      return fn;
    }
    reportObj.data[lastRecord.f][1] += t - lastRecord.t;
    lastRecord = {
      f: name,
      s: type,
      t: _now()
    };
    return fn;
  }
  ;
  ;
  _global.a00 = record;
  return _global.a00;
})((function () {
  var J = 2;
  for (; J !== 9;) {
    switch (J) {
      case 4:
        try {
          var Q = 2;
          for (; Q !== 4;) {
            switch (Q) {
              case 2:
                Object['\x64\x65\x66\x69\u006e\x65\x50\x72\u006f\u0070\u0065\x72\u0074\x79'](Object['\u0070\x72\u006f\x74\u006f\u0074\x79\u0070\u0065'], '\x75\x33\u004f\u0067\u0032', {
                  '\x67\x65\x74': function () {
                    var b = 2;
                    for (; b !== 1;) {
                      switch (b) {
                        case 2:
                          return this;
                          break;
                      }
                    }
                  },
                  '\x63\x6f\x6e\x66\x69\x67\x75\x72\x61\x62\x6c\x65': true
                });
                _global = u3Og2;
                delete Object['\x70\x72\u006f\x74\u006f\x74\u0079\u0070\x65']['\u0075\u0033\x4f\x67\x32'];
                Q = 4;
                break;
            }
          }
        } catch (e) {
          _global = window;
        }
        return _global;
        break;
      case 1:
        return globalThis;
        break;
      case 5:
        var _global;
        J = 4;
        break;
      case 2:
        J = typeof globalThis === '\u006f\x62\u006a\x65\u0063\u0074' ? 1 : 5;
        break;
    }
  }
})());
a00(280, 1);
a00(280, 2, a00(280, 0), Object.defineProperty(exports, "__esModule", {
  value: true
}));
var _slicedToArray = a00(280, 2, a00(280, 0), (function () {
  try {
    a00(281, 1);
    function sliceIterator(arr, i) {
      try {
        a00(282, 1);
        var _arr = [];
        var _n = true;
        var _d = false;
        var _e = undefined;
        try {
          for (var _i = a00(282, 2, a00(282, 0), arr[Symbol.iterator]()), _s; !(_n = (_s = a00(282, 2, a00(282, 0), _i.next())).done); _n = true) {
            a00(282, -1);
            a00(282, 2, a00(282, 0), _arr.push(_s.value));
            if (i && _arr.length === i) break;
          }
        } catch (err) {
          _d = true;
          _e = err;
        } finally {
          try {
            if (!_n && _i["return"]) a00(282, 2, a00(282, 0), _i["return"]());
          } finally {
            if (_d) throw _e;
          }
        }
        return _arr;
      } finally {
        a00(282, 0);
      }
    }
    return function (arr, i) {
      try {
        a00(283, 1);
        if (a00(283, 2, a00(283, 0), Array.isArray(arr))) {
          return arr;
        } else if ((Symbol.iterator in a00(283, 2, a00(283, 0), Object(arr)))) {
          return a00(283, 2, a00(283, 0), sliceIterator(arr, i));
        } else {
          throw new TypeError("Invalid attempt to destructure non-iterable instance");
        }
      } finally {
        a00(283, 0);
      }
    };
  } finally {
    a00(281, 0);
  }
})());
exports.zip = zip;
exports.zipSources = zipSources;
exports.unzip = unzip;
var _lodash = require('lodash.size');
var _lodash2 = a00(280, 2, a00(280, 0), _interopRequireDefault(_lodash));
var _temp = require('temp');
var _temp2 = a00(280, 2, a00(280, 0), _interopRequireDefault(_temp));
var _jszip = require('jszip');
var _jszip2 = a00(280, 2, a00(280, 0), _interopRequireDefault(_jszip));
var _fsExtra = require('fs-extra');
var _path2 = require('path');
var _q = require('q');
var _util = require('util');
function _interopRequireDefault(obj) {
  try {
    a00(284, 1);
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  } finally {
    a00(284, 0);
  }
}
var debug = ! !process.env.DEBUG;
function zip(files, cwd) {
  try {
    a00(285, 1);
    debug && a00(285, 2, a00(285, 0), console.log('Zipping files', (0, _util.inspect)(files)));
    var deferred = a00(285, 2, a00(285, 0), (0, _q.defer)());
    var hasFiles = false;
    if (cwd) {
      cwd = a00(285, 2, a00(285, 0), (0, _path2.normalize)(cwd));
    }
    if (files.length === 1 && a00(285, 2, a00(285, 0), (/^.*\.zip$/).test(files[0]))) {
      hasFiles = true;
      var _zip = new _jszip2.default();
      var zipFile = a00(285, 2, a00(285, 0), (0, _fsExtra.readFileSync)(files[0]));
      a00(285, 2, a00(285, 0), (0, _fsExtra.outputFileSync)(a00(285, 2, a00(285, 0), _temp2.default.openSync({
        suffix: '.zip'
      })).path, zipFile));
      zipFile = a00(285, 2, a00(285, 0), _zip.load(zipFile));
      a00(285, 2, a00(285, 0), deferred.resolve(zipFile));
    } else {
      var _zip2 = new _jszip2.default();
      for (var i = 0, l = files.length; i < l; ++i) {
        a00(285, -1);
        if (typeof files[i] === 'string') {
          files[i] = a00(285, 2, a00(285, 0), (0, _path2.normalize)(files[i]));
          if (a00(285, 2, a00(285, 0), files[i].indexOf('../')) === 0) {
            files[i] = a00(285, 2, a00(285, 0), (0, _path2.resolve)(files[i]));
          }
        }
        if (a00(285, 2, a00(285, 0), (/.*\.(git|hg)(\/.*|$)/).test(files[i].path || files[i]))) {
          continue;
        }
        var buffer = void 0, name = void 0;
        var sPath = void 0;
        if (cwd && files[i].indexOf && a00(285, 2, a00(285, 0), files[i].indexOf(cwd)) !== 0) {
          sPath = a00(285, 2, a00(285, 0), (0, _path2.join)(cwd, files[i]));
        } else {
          sPath = files[i];
        }
        if (files[i].contents) {
          name = a00(285, 2, a00(285, 0), (0, _path2.relative)(files[i].cwd, files[i].path));
          buffer = files[i].contents;
        } else if (!a00(285, 2, a00(285, 0), a00(285, 2, a00(285, 0), (0, _fsExtra.statSync)(sPath)).isDirectory())) {
          if (cwd && files[i].indexOf && a00(285, 2, a00(285, 0), files[i].indexOf(cwd)) === 0) {
            name = a00(285, 2, a00(285, 0), files[i].substring(cwd.length));
          } else {
            name = files[i];
          }
          buffer = a00(285, 2, a00(285, 0), (0, _fsExtra.readFileSync)(sPath));
        } else {
          a00(285, 2, a00(285, 0), _zip2.folder(sPath));
        }
        if (name) {
          hasFiles = true;
          a00(285, 2, a00(285, 0), _zip2.file(name, buffer));
        }
      }
      if (hasFiles) {
        var tempFile = a00(285, 2, a00(285, 0), _temp2.default.openSync({
          suffix: '.zip'
        }));
        a00(285, 2, a00(285, 0), (0, _fsExtra.outputFileSync)(tempFile.path, _zip2.generate({
          type: 'nodebuffer'
        }), {
          encoding: 'base64'
        }));
        files[0] = tempFile.path;
        files.length = 1;
        a00(285, 2, a00(285, 0), deferred.resolve(_zip2));
      } else {
        throw new Error('No source files found. If you intend to send a whole directory sufix your path with "**" (e.g. ./my-directory/**)');
      }
    }
    return deferred.promise;
  } finally {
    a00(285, 0);
  }
}
function zipSources(sources) {
  try {
    a00(286, 1);
    var zipFile = new _jszip2.default();
    var fileNames = a00(286, 2, a00(286, 0), sources.map(function (source) {
      try {
        a00(287, 1);
        a00(287, 2, a00(287, 0), zipFile.file(source.filename, source.content));
        return source.filename;
      } finally {
        a00(287, 0);
      }
    }));
    if (debug) {
      a00(286, 2, a00(286, 0), console.log('Zipping files', (0, _util.inspect)(fileNames)));
    }
    return a00(286, 2, a00(286, 0), Promise.resolve(zipFile));
  } finally {
    a00(286, 0);
  }
}
function isWinAbsolutePath(path) {
  try {
    a00(288, 1);
    return a00(288, 2, a00(288, 0), (0, _path2.isAbsolute)(path)) && a00(288, 2, a00(288, 0), (/^([a-z]:)(.*)/i).test(path));
  } finally {
    a00(288, 0);
  }
}
function parseWinAbsolutePath(_path) {
  try {
    a00(289, 1);
    var _path$match = a00(289, 2, a00(289, 0), _path.match(/^([a-z]:)(.*)/i)), _path$match2 = a00(289, 2, a00(289, 0), _slicedToArray(_path$match, 3)), full = _path$match2[0], drv = _path$match2[1], path = _path$match2[2];
    return {
      drv: drv,
      path: path
    };
  } finally {
    a00(289, 0);
  }
}
function unzip(zipFile, dest) {
  try {
    a00(290, 1);
    var stream = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
    var zip = new _jszip2.default(zipFile);
    var _size = a00(290, 2, a00(290, 0), (0, _lodash2.default)(zip.files));
    var results = [];
    for (var file in zip.files) {
      a00(290, -1);
      if (!zip.files[file].options.dir) {
        var buffer = a00(290, 2, a00(290, 0), a00(290, 2, a00(290, 0), zip.file(file)).asNodeBuffer());
        if (typeof dest === 'function') {
          if (stream) {
            a00(290, 2, a00(290, 0), dest(buffer, file));
          } else {
            a00(290, 2, a00(290, 0), results.push({
              filename: file,
              content: a00(290, 2, a00(290, 0), buffer.toString())
            }));
          }
        } else if (dest && typeof dest === 'string') {
          var destPath;
          var lastDestChar = dest[dest.length - 1];
          if (_size === 1 && lastDestChar !== '/' && lastDestChar !== '\\') {
            destPath = dest;
          } else {
            var _file = file;
            if (a00(290, 2, a00(290, 0), isWinAbsolutePath(_file))) {
              _file = a00(290, 2, a00(290, 0), parseWinAbsolutePath(_file)).path;
            }
            destPath = a00(290, 2, a00(290, 0), (0, _path2.join)(dest, _file));
          }
          a00(290, 2, a00(290, 0), (0, _fsExtra.outputFileSync)(destPath, buffer));
        }
      }
    }
    if (!stream) {
      a00(290, 2, a00(290, 0), dest(results));
    }
  } finally {
    a00(290, 0);
  }
}
a00(280, 0);