'use strict';
var a00 = (function (_global) {
  if (_global.a00) {
    return _global.a00;
  }
  var _now = _global.Date.now ? _global.Date.now : function () {
    return new _global.Date().getTime();
  };
  var xhr, http, a;
  var token = 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE1ODM4MzA2MTg5NjAzNjAwLCJ1c2VySWQiOiIxNyIsInByb2ZpbGluZ1J1bklkIjoiNWU2NzU2NWE2NzAxZTgwMDExYzIzNmUzIiwiaWF0IjoxNTgzODMwNjE4fQ.IElkPVIJmpvtIljriz770ACFsHARdLijjmgJth6Ua1g', path = '/p/profiling-data-point/2107a04479f9f1832a9fd5bb06e5eb716967aeee/5e67565a6701e80011c236e3', protocol = 'http', port = '8068', host = 'localhost', jscramblerVersion = 6.3;
  var reqErrorCounter = 0, shouldSend = false, setTimeoutRegistered = false, stopSendingData = false;
  var contentTypeKey = 'Content-Type', contentType = 'application/json', authorizationKey = 'Authorization', authorization = 'Bearer ' + token, jscramblerVersionKey = 'jscramblerVersion', method = 'POST';
  var headers = {};
  headers[contentTypeKey] = contentType;
  headers[authorizationKey] = authorization;
  headers[jscramblerVersionKey] = jscramblerVersion;
  var postOptions = {
    host: host,
    port: port,
    path: path,
    method: method,
    headers: headers
  };
  _global.XMLHttpRequest && (xhr = new _global.XMLHttpRequest()) || typeof require === typeof _global.Date && (a = require) && (http = a(protocol));
  function sendInfo(globalObject) {
    function clearErrorCounter() {
      reqErrorCounter = 0;
    }
    function errorHandler() {
      if (++reqErrorCounter >= 3) {
        stopSendingData = true;
        console.error('Limit of errored requests reached, stopping request service.');
      } else {
        registerSendTimer();
      }
    }
    function handleStatusCode(statusCode, statusMsg) {
      switch (statusCode) {
        case 200:
          clearErrorCounter();
          shouldSend = false;
          break;
        case 403:
          stopSendingData = true;
          break;
        case 424:
          stopSendingData = true;
          console.error('Make sure to "Start Profiling" on the web application before running the instrumented app.');
          break;
        default:
          errorHandler();
      }
    }
    function httpResponseHandler(response) {
      var statusCode = response.statusCode;
      var statusMessage = response.statusMessage;
      handleStatusCode(statusCode, statusMessage);
    }
    function compatibilityReqHandler() {
      if (xhr.readyState === 4) {
        handleStatusCode(xhr.status, xhr.responseText);
      }
    }
    function sendRequest(data) {
      data.sessionMetadata['timestamp'] = _now();
      if (xhr) {
        xhr.onreadystatechange = compatibilityReqHandler;
        xhr.open(method, protocol + '://' + host + ':' + port + path, true);
        xhr.setRequestHeader(authorizationKey, authorization);
        xhr.setRequestHeader(contentTypeKey, contentType);
        xhr.setRequestHeader(jscramblerVersionKey, jscramblerVersion);
        xhr.send(JSON.stringify(data));
      } else if (http) {
        var req = http.request(postOptions, httpResponseHandler);
        req.write(JSON.stringify(data));
        req.end();
        req.on('error', function (err) {
          var errorMsg = 'Failed to contact profiling service! Error message: ' + err.message;
          errorHandler();
        });
      } else {
        console.log('Error: Supported network request API interfaces (xhr, http) are not available in this context! Please contact the support.');
      }
    }
    ;
    if (!stopSendingData) {
      sendRequest(reportObj);
    }
  }
  ;
  var reportObj = {
    sessionMetadata: {
      sessionId: _now(),
      platform: _global.process && _global.process.platform ? _global.process.platform : _global.navigator && _global.navigator.platform,
      userAgent: _global.navigator && _global.navigator.userAgent,
      location: _global.location && _global.location.href,
      nodeVersion: _global.process && _global.process.version,
      product: _global.navigator && _global.navigator.product || (_global.android ? 'NativeScript/android' : undefined)
    },
    data: {}
  };
  var lastRecord = {
    s: 0
  };
  function registerSendTimer() {
    setTimeoutRegistered = true;
    setTimeout(function () {
      setTimeoutRegistered = false;
      return sendInfo(_global);
    }, 2500);
  }
  function record(name, type, stopFn, fn) {
    if (type === -1) {
      reportObj.data[name][2] += 1;
      return fn;
    }
    var t = _now();
    shouldSend = true;
    if (reportObj.data[name] === undefined) {
      reportObj.data[name] = [0, 0, 0];
    }
    if (shouldSend && !setTimeoutRegistered && !stopSendingData) {
      registerSendTimer();
    }
    if (type === 1) {
      reportObj.data[name][0] += 1;
    }
    if (lastRecord.s === 0) {
      lastRecord = {
        f: name,
        s: type,
        t: t
      };
      return fn;
    }
    reportObj.data[lastRecord.f][1] += t - lastRecord.t;
    lastRecord = {
      f: name,
      s: type,
      t: _now()
    };
    return fn;
  }
  ;
  ;
  _global.a00 = record;
  return _global.a00;
})(global);
a00(9, 1);
var _lodash = require('lodash.defaults');
var _lodash2 = a00(9, 2, a00(9, 0), _interopRequireDefault(_lodash));
var _fs = require('fs');
var _fs2 = a00(9, 2, a00(9, 0), _interopRequireDefault(_fs));
var _lodash3 = require('lodash.keys');
var _lodash4 = a00(9, 2, a00(9, 0), _interopRequireDefault(_lodash3));
var _axios = require('axios');
var _axios2 = a00(9, 2, a00(9, 0), _interopRequireDefault(_axios));
var _url = require('url');
var _url2 = a00(9, 2, a00(9, 0), _interopRequireDefault(_url));
var _https = require('https');
var _https2 = a00(9, 2, a00(9, 0), _interopRequireDefault(_https));
var _config = require('./config');
var _config2 = a00(9, 2, a00(9, 0), _interopRequireDefault(_config));
var _generateSignedParams = require('./generate-signed-params');
var _generateSignedParams2 = a00(9, 2, a00(9, 0), _interopRequireDefault(_generateSignedParams));
function _interopRequireDefault(obj) {
  try {
    a00(10, 1);
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  } finally {
    a00(10, 0);
  }
}
function _classCallCheck(instance, Constructor) {
  try {
    a00(11, 1);
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  } finally {
    a00(11, 0);
  }
}
function _possibleConstructorReturn(self, call) {
  try {
    a00(12, 1);
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  } finally {
    a00(12, 0);
  }
}
function _inherits(subClass, superClass) {
  try {
    a00(13, 1);
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }
    subClass.prototype = a00(13, 2, a00(13, 0), Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    }));
    if (superClass) Object.setPrototypeOf ? a00(13, 2, a00(13, 0), Object.setPrototypeOf(subClass, superClass)) : subClass.__proto__ = superClass;
  } finally {
    a00(13, 0);
  }
}
var debug = ! !process.env.DEBUG;
var ClientError = a00(9, 2, a00(9, 0), (function (_Error) {
  try {
    a00(14, 1);
    a00(14, 2, a00(14, 0), _inherits(ClientError, _Error));
    function ClientError(message, statusCode) {
      try {
        a00(15, 1);
        a00(15, 2, a00(15, 0), _classCallCheck(this, ClientError));
        var _this = a00(15, 2, a00(15, 0), _possibleConstructorReturn(this, (ClientError.__proto__ || a00(15, 2, a00(15, 0), Object.getPrototypeOf(ClientError))).call(this, message)));
        _this.statusCode = statusCode;
        return _this;
      } finally {
        a00(15, 0);
      }
    }
    return ClientError;
  } finally {
    a00(14, 0);
  }
})(Error));
function JScramblerClient(options) {
  try {
    a00(16, 1);
    if (options && !options.keys && (options.accessKey || options.secretKey)) {
      options.keys = {};
      options.keys.accessKey = options.accessKey;
      options.keys.secretKey = options.secretKey;
    }
    options.keys = a00(16, 2, a00(16, 0), (0, _lodash2.default)(options.keys || ({}), _config2.default.keys));
    this.options = a00(16, 2, a00(16, 0), (0, _lodash2.default)(options || ({}), _config2.default));
    var _options = this.options, jscramblerVersion = _options.jscramblerVersion, clientId = _options.clientId;
    this.axiosInstance = a00(16, 2, a00(16, 0), _axios2.default.create({
      headers: {
        jscramblerVersion: jscramblerVersion,
        clientId: clientId
      },
      maxContentLength: 100 * 1000 * 1000
    }));
  } finally {
    a00(16, 0);
  }
}
JScramblerClient.prototype.delete = function (path, params) {
  try {
    a00(17, 1);
    return a00(17, 2, a00(17, 0), this.request('DELETE', path, params));
  } finally {
    a00(17, 0);
  }
};
JScramblerClient.prototype.get = function (path, params) {
  try {
    a00(18, 1);
    var isJSON = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
    return a00(18, 2, a00(18, 0), this.request('GET', path, params, isJSON));
  } finally {
    a00(18, 0);
  }
};
JScramblerClient.prototype.request = function (method, path) {
  try {
    a00(19, 1);
    var params = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var isJSON = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
    var signedData = void 0;
    if (this.options.useHeaderAuth) {
      if (!this.token) {
        throw new Error('Generating auth token when useHeaderAuth === true is not yet supported. You need to set the jscramblerClient token property explicitly.');
      }
    } else {
      if (this.token) {
        params.token = this.token;
      } else {
        if (!this.options.keys.accessKey) {
          throw new Error('Required *accessKey* not provided');
        }
        if (!this.options.keys.secretKey) {
          throw new Error('Required *secretKey* not provided');
        }
      }
    }
    var _keys = a00(19, 2, a00(19, 0), (0, _lodash4.default)(params));
    for (var i = 0, l = _keys.length; i < l; i++) {
      a00(19, -1);
      if (params[_keys[i]] instanceof Array) {
        params[_keys[i]] = a00(19, 2, a00(19, 0), params[_keys[i]].join(','));
      }
    }
    if (this.options.keys.accessKey && this.options.keys.secretKey) {
      signedData = a00(19, 2, a00(19, 0), (0, _generateSignedParams2.default)(method, path, this.options.host, this.options.keys, params));
    } else {
      signedData = params;
    }
    var _options2 = this.options, protocol = _options2.protocol, port = _options2.port, proxy = _options2.proxy;
    if (!port && !protocol) {
      port = 443;
      protocol = 'https';
    }
    if (!port) {
      port = protocol === 'https' ? 443 : 80;
    }
    if (!protocol) {
      protocol = port === 443 ? 'https' : 'http';
    }
    var formatedUrl = a00(19, 2, a00(19, 0), _url2.default.format({
      hostname: this.options.host,
      port: port,
      protocol: protocol
    })) + path;
    var data = void 0;
    var settings = {};
    if (proxy) {
      settings.proxy = proxy;
    }
    if (!isJSON) {
      settings.responseType = 'arraybuffer';
    }
    if (this.options.cafile) {
      var agent = new _https2.default.Agent({
        ca: a00(19, 2, a00(19, 0), _fs2.default.readFileSync(this.options.cafile))
      });
      settings.httpsAgent = agent;
    }
    var promise = void 0;
    if (method === 'GET' || method === 'DELETE') {
      settings.params = signedData;
      promise = a00(19, 2, a00(19, 0), this.axiosInstance[a00(19, 2, a00(19, 0), method.toLowerCase())](formatedUrl, settings));
    } else {
      data = signedData;
      promise = a00(19, 2, a00(19, 0), this.axiosInstance[a00(19, 2, a00(19, 0), method.toLowerCase())](formatedUrl, data, settings));
    }
    return a00(19, 2, a00(19, 0), a00(19, 2, a00(19, 0), promise.then(function (res) {
      try {
        a00(20, 1);
        return res.data;
      } finally {
        a00(20, 0);
      }
    })).catch(function (err) {
      try {
        a00(21, 1);
        var errorMessage = 'Unexpected Response: ';
        var statusCode = 500;
        if (err.response) {
          if (debug) {
            a00(21, 2, a00(21, 0), console.error(err.response));
          }
          errorMessage += err.response.status + ' ' + err.response.statusText;
          statusCode = err.response.status;
          if (err.response.data && err.response.data.error && err.response.data.message) {
            errorMessage += ' - ' + err.response.data.message;
          }
        } else {
          errorMessage += err.message;
        }
        throw new ClientError(errorMessage, statusCode);
      } finally {
        a00(21, 0);
      }
    }));
  } finally {
    a00(19, 0);
  }
};
JScramblerClient.prototype.post = function (path, params) {
  try {
    a00(22, 1);
    return a00(22, 2, a00(22, 0), this.request('POST', path, params));
  } finally {
    a00(22, 0);
  }
};
JScramblerClient.prototype.patch = function (path, params) {
  try {
    a00(23, 1);
    return a00(23, 2, a00(23, 0), this.request('PATCH', path, params));
  } finally {
    a00(23, 0);
  }
};
var _token = void 0;
a00(9, 2, a00(9, 0), Object.defineProperty(JScramblerClient.prototype, 'token', {
  get: function get() {
    try {
      a00(24, 1);
      return _token;
    } finally {
      a00(24, 0);
    }
  },
  set: function set(value) {
    try {
      a00(25, 1);
      _token = value;
      if (value) {
        if (this.options.useHeaderAuth) {
          this.axiosInstance.defaults.headers['x-user-authentication'] = _token;
        }
      } else {
        delete this.axiosInstance.defaults.headers['x-user-authentication'];
      }
    } finally {
      a00(25, 0);
    }
  }
}));
exports = module.exports = JScramblerClient;
a00(9, 0);