'use strict';
var a00 = (function (_global) {
  if (_global.a00) {
    return _global.a00;
  }
  var _now = _global.Date.now ? _global.Date.now : function () {
    return new _global.Date().getTime();
  };
  var xhr, http, a;
  var token = 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE1ODM4MzA2MTg5NjAzNjAwLCJ1c2VySWQiOiIxNyIsInByb2ZpbGluZ1J1bklkIjoiNWU2NzU2NWE2NzAxZTgwMDExYzIzNmUzIiwiaWF0IjoxNTgzODMwNjE4fQ.IElkPVIJmpvtIljriz770ACFsHARdLijjmgJth6Ua1g', path = '/p/profiling-data-point/2107a04479f9f1832a9fd5bb06e5eb716967aeee/5e67565a6701e80011c236e3', protocol = 'http', port = '8068', host = 'localhost', jscramblerVersion = 6.3;
  var reqErrorCounter = 0, shouldSend = false, setTimeoutRegistered = false, stopSendingData = false;
  var contentTypeKey = 'Content-Type', contentType = 'application/json', authorizationKey = 'Authorization', authorization = 'Bearer ' + token, jscramblerVersionKey = 'jscramblerVersion', method = 'POST';
  var headers = {};
  headers[contentTypeKey] = contentType;
  headers[authorizationKey] = authorization;
  headers[jscramblerVersionKey] = jscramblerVersion;
  var postOptions = {
    host: host,
    port: port,
    path: path,
    method: method,
    headers: headers
  };
  _global.XMLHttpRequest && (xhr = new _global.XMLHttpRequest()) || typeof require === typeof _global.Date && (a = require) && (http = a(protocol));
  function sendInfo(globalObject) {
    function clearErrorCounter() {
      reqErrorCounter = 0;
    }
    function errorHandler() {
      if (++reqErrorCounter >= 3) {
        stopSendingData = true;
        console.error('Limit of errored requests reached, stopping request service.');
      } else {
        registerSendTimer();
      }
    }
    function handleStatusCode(statusCode, statusMsg) {
      switch (statusCode) {
        case 200:
          clearErrorCounter();
          shouldSend = false;
          break;
        case 403:
          stopSendingData = true;
          break;
        case 424:
          stopSendingData = true;
          console.error('Make sure to "Start Profiling" on the web application before running the instrumented app.');
          break;
        default:
          errorHandler();
      }
    }
    function httpResponseHandler(response) {
      var statusCode = response.statusCode;
      var statusMessage = response.statusMessage;
      handleStatusCode(statusCode, statusMessage);
    }
    function compatibilityReqHandler() {
      if (xhr.readyState === 4) {
        handleStatusCode(xhr.status, xhr.responseText);
      }
    }
    function sendRequest(data) {
      data.sessionMetadata['timestamp'] = _now();
      if (xhr) {
        xhr.onreadystatechange = compatibilityReqHandler;
        xhr.open(method, protocol + '://' + host + ':' + port + path, true);
        xhr.setRequestHeader(authorizationKey, authorization);
        xhr.setRequestHeader(contentTypeKey, contentType);
        xhr.setRequestHeader(jscramblerVersionKey, jscramblerVersion);
        xhr.send(JSON.stringify(data));
      } else if (http) {
        var req = http.request(postOptions, httpResponseHandler);
        req.write(JSON.stringify(data));
        req.end();
        req.on('error', function (err) {
          var errorMsg = 'Failed to contact profiling service! Error message: ' + err.message;
          errorHandler();
        });
      } else {
        console.log('Error: Supported network request API interfaces (xhr, http) are not available in this context! Please contact the support.');
      }
    }
    ;
    if (!stopSendingData) {
      sendRequest(reportObj);
    }
  }
  ;
  var reportObj = {
    sessionMetadata: {
      sessionId: _now(),
      platform: _global.process && _global.process.platform ? _global.process.platform : _global.navigator && _global.navigator.platform,
      userAgent: _global.navigator && _global.navigator.userAgent,
      location: _global.location && _global.location.href,
      nodeVersion: _global.process && _global.process.version,
      product: _global.navigator && _global.navigator.product || (_global.android ? 'NativeScript/android' : undefined)
    },
    data: {}
  };
  var lastRecord = {
    s: 0
  };
  function registerSendTimer() {
    setTimeoutRegistered = true;
    setTimeout(function () {
      setTimeoutRegistered = false;
      return sendInfo(_global);
    }, 2500);
  }
  function record(name, type, stopFn, fn) {
    if (type === -1) {
      reportObj.data[name][2] += 1;
      return fn;
    }
    var t = _now();
    shouldSend = true;
    if (reportObj.data[name] === undefined) {
      reportObj.data[name] = [0, 0, 0];
    }
    if (shouldSend && !setTimeoutRegistered && !stopSendingData) {
      registerSendTimer();
    }
    if (type === 1) {
      reportObj.data[name][0] += 1;
    }
    if (lastRecord.s === 0) {
      lastRecord = {
        f: name,
        s: type,
        t: t
      };
      return fn;
    }
    reportObj.data[lastRecord.f][1] += t - lastRecord.t;
    lastRecord = {
      f: name,
      s: type,
      t: _now()
    };
    return fn;
  }
  ;
  ;
  _global.a00 = record;
  return _global.a00;
})(global);
a00(33, 1);
a00(33, 2, a00(33, 0), Object.defineProperty(exports, "__esModule", {
  value: true
}));
var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  try {
    a00(34, 1);
    return typeof obj;
  } finally {
    a00(34, 0);
  }
} : function (obj) {
  try {
    a00(35, 1);
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  } finally {
    a00(35, 0);
  }
};
var getIntrospection = a00(33, 2, a00(33, 0), (function () {
  try {
    a00(36, 1);
    var _ref = a00(36, 2, a00(36, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee(client, typeName) {
      try {
        a00(37, 1);
        var _introspection;
        return a00(37, 2, a00(37, 0), regeneratorRuntime.wrap(function _callee$(_context) {
          try {
            a00(38, 1);
            while (1) {
              a00(38, -1);
              switch (_context.prev = _context.next) {
                case 0:
                  _introspection = void 0;
                  _context.prev = 1;
                  _context.next = 4;
                  return a00(38, 2, a00(38, 0), introspection.type(client, typeName));
                case 4:
                  _introspection = _context.sent;
                  _context.next = 9;
                  break;
                case 7:
                  _context.prev = 7;
                  _context.t0 = a00(38, 2, a00(38, 0), _context['catch'](1));
                case 9:
                  return a00(38, 2, a00(38, 0), _context.abrupt('return', _introspection));
                case 10:
                case 'end':
                  return a00(38, 2, a00(38, 0), _context.stop());
              }
            }
          } finally {
            a00(38, 0);
          }
        }, _callee, this, [[1, 7]]));
      } finally {
        a00(37, 0);
      }
    })));
    return function getIntrospection(_x, _x2) {
      try {
        a00(39, 1);
        return a00(39, 2, a00(39, 0), _ref.apply(this, arguments));
      } finally {
        a00(39, 0);
      }
    };
  } finally {
    a00(36, 0);
  }
})());
var _introspection2 = require('./introspection');
var introspection = a00(33, 2, a00(33, 0), _interopRequireWildcard(_introspection2));
function _interopRequireWildcard(obj) {
  try {
    a00(40, 1);
    if (obj && obj.__esModule) {
      return obj;
    } else {
      var newObj = {};
      if (obj != null) {
        for (var key in obj) {
          a00(40, -1);
          if (a00(40, 2, a00(40, 0), Object.prototype.hasOwnProperty.call(obj, key))) newObj[key] = obj[key];
        }
      }
      newObj.default = obj;
      return newObj;
    }
  } finally {
    a00(40, 0);
  }
}
function _asyncToGenerator(fn) {
  try {
    a00(41, 1);
    return function () {
      try {
        a00(42, 1);
        var gen = a00(42, 2, a00(42, 0), fn.apply(this, arguments));
        return new Promise(function (resolve, reject) {
          try {
            a00(43, 1);
            function step(key, arg) {
              try {
                a00(44, 1);
                try {
                  var info = a00(44, 2, a00(44, 0), gen[key](arg));
                  var value = info.value;
                } catch (error) {
                  a00(44, 2, a00(44, 0), reject(error));
                  return;
                }
                if (info.done) {
                  a00(44, 2, a00(44, 0), resolve(value));
                } else {
                  return a00(44, 2, a00(44, 0), a00(44, 2, a00(44, 0), Promise.resolve(value)).then(function (value) {
                    try {
                      a00(45, 1);
                      a00(45, 2, a00(45, 0), step("next", value));
                    } finally {
                      a00(45, 0);
                    }
                  }, function (err) {
                    try {
                      a00(46, 1);
                      a00(46, 2, a00(46, 0), step("throw", err));
                    } finally {
                      a00(46, 0);
                    }
                  }));
                }
              } finally {
                a00(44, 0);
              }
            }
            return a00(43, 2, a00(43, 0), step("next"));
          } finally {
            a00(43, 0);
          }
        });
      } finally {
        a00(42, 0);
      }
    };
  } finally {
    a00(41, 0);
  }
}
function fragmentToQL(fragment) {
  try {
    a00(47, 1);
    var iterate = function iterate(i) {
      try {
        a00(48, 1);
        return a00(48, 2, a00(48, 0), a00(48, 2, a00(48, 0), a00(48, 2, a00(48, 0), Object.keys(i)).map(function (key) {
          try {
            a00(49, 1);
            var result;
            var value = i[key];
            if ((typeof value === 'undefined' ? 'undefined' : a00(49, 2, a00(49, 0), _typeof(value))) === 'object') {
              result = key + ' { ' + a00(49, 2, a00(49, 0), iterate(value)) + ' }';
            } else {
              result = key;
            }
            return result;
          } finally {
            a00(49, 0);
          }
        })).join(','));
      } finally {
        a00(48, 0);
      }
    };
    return a00(47, 2, a00(47, 0), iterate(fragment));
  } finally {
    a00(47, 0);
  }
}
function getAvaliableFragments(a, b) {
  try {
    a00(50, 1);
    var fragment = {};
    a00(50, 2, a00(50, 0), a00(50, 2, a00(50, 0), Object.keys(b)).forEach(function (field) {
      try {
        a00(51, 1);
        var _field = a00(51, 2, a00(51, 0), a.find(function (f) {
          try {
            a00(52, 1);
            return f.name === field;
          } finally {
            a00(52, 0);
          }
        }));
        if (_field) {
          if (a00(51, 2, a00(51, 0), _typeof(b[field])) === 'object' && _field.type.ofType.kind === 'OBJECT') {
            fragment[field] = b[field];
          } else {
            fragment[field] = 1;
          }
        }
      } finally {
        a00(51, 0);
      }
    }));
    return fragment;
  } finally {
    a00(50, 0);
  }
}
var protectionFields = {
  _id: 1,
  state: 1,
  bail: 1,
  growthWarning: 1,
  errorMessage: 1,
  size: 1,
  transformedSize: 1
};
var deprecationFields = {
  type: 1,
  entity: 1
};
var sourceFields = {
  filename: 1
};
var errorMessageFields = {
  message: 1,
  line: 1,
  column: 1,
  fatal: 1
};
exports.default = a00(33, 2, a00(33, 0), (function () {
  try {
    a00(53, 1);
    var _ref2 = a00(53, 2, a00(53, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee2(client) {
      try {
        a00(54, 1);
        var appProtection, deprecation, source, errorMessage, fragments;
        return a00(54, 2, a00(54, 0), regeneratorRuntime.wrap(function _callee2$(_context2) {
          try {
            a00(55, 1);
            while (1) {
              a00(55, -1);
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.next = 2;
                  return a00(55, 2, a00(55, 0), getIntrospection(client, 'ApplicationProtection'));
                case 2:
                  appProtection = _context2.sent;
                  _context2.next = 5;
                  return a00(55, 2, a00(55, 0), getIntrospection(client, 'Deprecation'));
                case 5:
                  deprecation = _context2.sent;
                  _context2.next = 8;
                  return a00(55, 2, a00(55, 0), getIntrospection(client, 'ApplicationSource'));
                case 8:
                  source = _context2.sent;
                  _context2.next = 11;
                  return a00(55, 2, a00(55, 0), getIntrospection(client, 'ErrorMessages'));
                case 11:
                  errorMessage = _context2.sent;
                  fragments = {
                    application: {
                      name: 1
                    },
                    applicationProtection: {}
                  };
                  fragments.applicationProtection = appProtection && a00(55, 2, a00(55, 0), getAvaliableFragments(appProtection.fields, protectionFields));
                  fragments.applicationProtection.deprecations = deprecation && a00(55, 2, a00(55, 0), getAvaliableFragments(deprecation.fields, deprecationFields));
                  fragments.applicationProtection.sources = source && a00(55, 2, a00(55, 0), getAvaliableFragments(source.fields, sourceFields));
                  fragments.applicationProtection.sources.errorMessages = errorMessage && a00(55, 2, a00(55, 0), getAvaliableFragments(errorMessage.fields, errorMessageFields));
                  return a00(55, 2, a00(55, 0), _context2.abrupt('return', {
                    application: a00(55, 2, a00(55, 0), fragmentToQL(fragments.application)),
                    applicationProtection: a00(55, 2, a00(55, 0), fragmentToQL(fragments.applicationProtection))
                  }));
                case 18:
                case 'end':
                  return a00(55, 2, a00(55, 0), _context2.stop());
              }
            }
          } finally {
            a00(55, 0);
          }
        }, _callee2, this));
      } finally {
        a00(54, 0);
      }
    })));
    return function (_x3) {
      try {
        a00(56, 1);
        return a00(56, 2, a00(56, 0), _ref2.apply(this, arguments));
      } finally {
        a00(56, 0);
      }
    };
  } finally {
    a00(53, 0);
  }
})());
a00(33, 0);