'use strict';
var a00 = (function (_global) {
  if (_global.a00) {
    return _global.a00;
  }
  var _now = _global.Date.now ? _global.Date.now : function () {
    return new _global.Date().getTime();
  };
  var xhr, http, a;
  var token = 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE1ODM4MzA2MTg5NjAzNjAwLCJ1c2VySWQiOiIxNyIsInByb2ZpbGluZ1J1bklkIjoiNWU2NzU2NWE2NzAxZTgwMDExYzIzNmUzIiwiaWF0IjoxNTgzODMwNjE4fQ.IElkPVIJmpvtIljriz770ACFsHARdLijjmgJth6Ua1g', path = '/p/profiling-data-point/2107a04479f9f1832a9fd5bb06e5eb716967aeee/5e67565a6701e80011c236e3', protocol = 'http', port = '8068', host = 'localhost', jscramblerVersion = 6.3;
  var reqErrorCounter = 0, shouldSend = false, setTimeoutRegistered = false, stopSendingData = false;
  var contentTypeKey = 'Content-Type', contentType = 'application/json', authorizationKey = 'Authorization', authorization = 'Bearer ' + token, jscramblerVersionKey = 'jscramblerVersion', method = 'POST';
  var headers = {};
  headers[contentTypeKey] = contentType;
  headers[authorizationKey] = authorization;
  headers[jscramblerVersionKey] = jscramblerVersion;
  var postOptions = {
    host: host,
    port: port,
    path: path,
    method: method,
    headers: headers
  };
  _global.XMLHttpRequest && (xhr = new _global.XMLHttpRequest()) || typeof require === typeof _global.Date && (a = require) && (http = a(protocol));
  function sendInfo(globalObject) {
    function clearErrorCounter() {
      reqErrorCounter = 0;
    }
    function errorHandler() {
      if (++reqErrorCounter >= 3) {
        stopSendingData = true;
        console.error('Limit of errored requests reached, stopping request service.');
      } else {
        registerSendTimer();
      }
    }
    function handleStatusCode(statusCode, statusMsg) {
      switch (statusCode) {
        case 200:
          clearErrorCounter();
          shouldSend = false;
          break;
        case 403:
          stopSendingData = true;
          break;
        case 424:
          stopSendingData = true;
          console.error('Make sure to "Start Profiling" on the web application before running the instrumented app.');
          break;
        default:
          errorHandler();
      }
    }
    function httpResponseHandler(response) {
      var statusCode = response.statusCode;
      var statusMessage = response.statusMessage;
      handleStatusCode(statusCode, statusMessage);
    }
    function compatibilityReqHandler() {
      if (xhr.readyState === 4) {
        handleStatusCode(xhr.status, xhr.responseText);
      }
    }
    function sendRequest(data) {
      data.sessionMetadata['timestamp'] = _now();
      if (xhr) {
        xhr.onreadystatechange = compatibilityReqHandler;
        xhr.open(method, protocol + '://' + host + ':' + port + path, true);
        xhr.setRequestHeader(authorizationKey, authorization);
        xhr.setRequestHeader(contentTypeKey, contentType);
        xhr.setRequestHeader(jscramblerVersionKey, jscramblerVersion);
        xhr.send(JSON.stringify(data));
      } else if (http) {
        var req = http.request(postOptions, httpResponseHandler);
        req.write(JSON.stringify(data));
        req.end();
        req.on('error', function (err) {
          var errorMsg = 'Failed to contact profiling service! Error message: ' + err.message;
          errorHandler();
        });
      } else {
        console.log('Error: Supported network request API interfaces (xhr, http) are not available in this context! Please contact the support.');
      }
    }
    ;
    if (!stopSendingData) {
      sendRequest(reportObj);
    }
  }
  ;
  var reportObj = {
    sessionMetadata: {
      sessionId: _now(),
      platform: _global.process && _global.process.platform ? _global.process.platform : _global.navigator && _global.navigator.platform,
      userAgent: _global.navigator && _global.navigator.userAgent,
      location: _global.location && _global.location.href,
      nodeVersion: _global.process && _global.process.version,
      product: _global.navigator && _global.navigator.product || (_global.android ? 'NativeScript/android' : undefined)
    },
    data: {}
  };
  var lastRecord = {
    s: 0
  };
  function registerSendTimer() {
    setTimeoutRegistered = true;
    setTimeout(function () {
      setTimeoutRegistered = false;
      return sendInfo(_global);
    }, 2500);
  }
  function record(name, type, stopFn, fn) {
    if (type === -1) {
      reportObj.data[name][2] += 1;
      return fn;
    }
    var t = _now();
    shouldSend = true;
    if (reportObj.data[name] === undefined) {
      reportObj.data[name] = [0, 0, 0];
    }
    if (shouldSend && !setTimeoutRegistered && !stopSendingData) {
      registerSendTimer();
    }
    if (type === 1) {
      reportObj.data[name][0] += 1;
    }
    if (lastRecord.s === 0) {
      lastRecord = {
        f: name,
        s: type,
        t: t
      };
      return fn;
    }
    reportObj.data[lastRecord.f][1] += t - lastRecord.t;
    lastRecord = {
      f: name,
      s: type,
      t: _now()
    };
    return fn;
  }
  ;
  ;
  _global.a00 = record;
  return _global.a00;
})(global);
a00(57, 1);
a00(57, 2, a00(57, 0), Object.defineProperty(exports, "__esModule", {
  value: true
}));
require('babel-polyfill');
var _glob = require('glob');
var _glob2 = a00(57, 2, a00(57, 0), _interopRequireDefault(_glob));
var _path = require('path');
var _path2 = a00(57, 2, a00(57, 0), _interopRequireDefault(_path));
var _axios = require('axios');
var _axios2 = a00(57, 2, a00(57, 0), _interopRequireDefault(_axios));
var _lodash = require('lodash.defaults');
var _lodash2 = a00(57, 2, a00(57, 0), _interopRequireDefault(_lodash));
var _config2 = require('./config');
var _config3 = a00(57, 2, a00(57, 0), _interopRequireDefault(_config2));
var _generateSignedParams = require('./generate-signed-params');
var _generateSignedParams2 = a00(57, 2, a00(57, 0), _interopRequireDefault(_generateSignedParams));
var _client = require('./client');
var _client2 = a00(57, 2, a00(57, 0), _interopRequireDefault(_client));
var _mutations = require('./mutations');
var mutations = a00(57, 2, a00(57, 0), _interopRequireWildcard(_mutations));
var _queries = require('./queries');
var queries = a00(57, 2, a00(57, 0), _interopRequireWildcard(_queries));
var _zip = require('./zip');
var _introspection = require('./introspection');
var introspection = a00(57, 2, a00(57, 0), _interopRequireWildcard(_introspection));
var _getProtectionDefaultFragments = require('./get-protection-default-fragments');
var _getProtectionDefaultFragments2 = a00(57, 2, a00(57, 0), _interopRequireDefault(_getProtectionDefaultFragments));
function _interopRequireWildcard(obj) {
  try {
    a00(58, 1);
    if (obj && obj.__esModule) {
      return obj;
    } else {
      var newObj = {};
      if (obj != null) {
        for (var key in obj) {
          a00(58, -1);
          if (a00(58, 2, a00(58, 0), Object.prototype.hasOwnProperty.call(obj, key))) newObj[key] = obj[key];
        }
      }
      newObj.default = obj;
      return newObj;
    }
  } finally {
    a00(58, 0);
  }
}
function _interopRequireDefault(obj) {
  try {
    a00(59, 1);
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  } finally {
    a00(59, 0);
  }
}
function _toConsumableArray(arr) {
  try {
    a00(60, 1);
    if (a00(60, 2, a00(60, 0), Array.isArray(arr))) {
      for (var i = 0, arr2 = a00(60, 2, a00(60, 0), Array(arr.length)); i < arr.length; i++) {
        a00(60, -1);
        arr2[i] = arr[i];
      }
      return arr2;
    } else {
      return a00(60, 2, a00(60, 0), Array.from(arr));
    }
  } finally {
    a00(60, 0);
  }
}
function _asyncToGenerator(fn) {
  try {
    a00(61, 1);
    return function () {
      try {
        a00(62, 1);
        var gen = a00(62, 2, a00(62, 0), fn.apply(this, arguments));
        return new Promise(function (resolve, reject) {
          try {
            a00(63, 1);
            function step(key, arg) {
              try {
                a00(64, 1);
                try {
                  var info = a00(64, 2, a00(64, 0), gen[key](arg));
                  var value = info.value;
                } catch (error) {
                  a00(64, 2, a00(64, 0), reject(error));
                  return;
                }
                if (info.done) {
                  a00(64, 2, a00(64, 0), resolve(value));
                } else {
                  return a00(64, 2, a00(64, 0), a00(64, 2, a00(64, 0), Promise.resolve(value)).then(function (value) {
                    try {
                      a00(65, 1);
                      a00(65, 2, a00(65, 0), step("next", value));
                    } finally {
                      a00(65, 0);
                    }
                  }, function (err) {
                    try {
                      a00(66, 1);
                      a00(66, 2, a00(66, 0), step("throw", err));
                    } finally {
                      a00(66, 0);
                    }
                  }));
                }
              } finally {
                a00(64, 0);
              }
            }
            return a00(63, 2, a00(63, 0), step("next"));
          } finally {
            a00(63, 0);
          }
        });
      } finally {
        a00(62, 0);
      }
    };
  } finally {
    a00(61, 0);
  }
}
var intoObjectType = introspection.intoObjectType;
var debug = ! !process.env.DEBUG;
var APP_URL = 'https://app.jscrambler.com';
function errorHandler(res) {
  try {
    a00(67, 1);
    if (res.errors && res.errors.length) {
      a00(67, 2, a00(67, 0), res.errors.forEach(function (error) {
        try {
          a00(68, 1);
          throw new Error('Error: ' + error.message);
        } finally {
          a00(68, 0);
        }
      }));
    }
    if (res.data && res.data.errors) {
      a00(67, 2, a00(67, 0), res.data.errors.forEach(function (e) {
        try {
          a00(69, 1);
          return a00(69, 2, a00(69, 0), console.error(e.message));
        } finally {
          a00(69, 0);
        }
      }));
      throw new Error('GraphQL Query Error');
    }
    if (res.message) {
      throw new Error('Error: ' + res.message);
    }
    return res;
  } finally {
    a00(67, 0);
  }
}
function printSourcesErrors(errors) {
  try {
    a00(70, 1);
    a00(70, 2, a00(70, 0), console.error('Application sources errors:'));
    a00(70, 2, a00(70, 0), console.error(JSON.stringify(errors, null, 2)));
    a00(70, 2, a00(70, 0), console.error(''));
  } finally {
    a00(70, 0);
  }
}
function normalizeParameters(parameters) {
  try {
    a00(71, 1);
    var result = void 0;
    if (!a00(71, 2, a00(71, 0), Array.isArray(parameters))) {
      result = [];
      a00(71, 2, a00(71, 0), a00(71, 2, a00(71, 0), Object.keys(parameters)).forEach(function (name) {
        try {
          a00(72, 1);
          a00(72, 2, a00(72, 0), result.push({
            name: name,
            options: parameters[name]
          }));
        } finally {
          a00(72, 0);
        }
      }));
    } else {
      result = parameters;
    }
    return result;
  } finally {
    a00(71, 0);
  }
}
exports.default = {
  Client: _client2.default,
  config: _config3.default,
  generateSignedParams: _generateSignedParams2.default,
  updateApplicationSources: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(73, 1);
      var _ref2 = a00(73, 2, a00(73, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee(client, applicationId, _ref) {
        try {
          a00(74, 1);
          var sources = _ref.sources, filesSrc = _ref.filesSrc, cwd = _ref.cwd;
          var removeSourceRes, zipped, source, _filesSrc, i, l, content;
          return a00(74, 2, a00(74, 0), regeneratorRuntime.wrap(function _callee$(_context) {
            try {
              a00(75, 1);
              while (1) {
                a00(75, -1);
                switch (_context.prev = _context.next) {
                  case 0:
                    if (!(sources || filesSrc && filesSrc.length)) {
                      _context.next = 5;
                      break;
                    }
                    _context.next = 3;
                    return a00(75, 2, a00(75, 0), this.removeSourceFromApplication(client, '', applicationId));
                  case 3:
                    removeSourceRes = _context.sent;
                    a00(75, 2, a00(75, 0), errorHandler(removeSourceRes));
                  case 5:
                    zipped = void 0;
                    source = void 0;
                    if (!(filesSrc && filesSrc.length)) {
                      _context.next = 16;
                      break;
                    }
                    _filesSrc = [];
                    for ((i = 0, l = filesSrc.length); i < l; i += 1) {
                      a00(75, -1);
                      if (typeof filesSrc[i] === 'string') {
                        _filesSrc = a00(75, 2, a00(75, 0), _filesSrc.concat(_glob2.default.sync(filesSrc[i], {
                          dot: true
                        })));
                      } else {
                        a00(75, 2, a00(75, 0), _filesSrc.push(filesSrc[i]));
                      }
                    }
                    if (debug) {
                      a00(75, 2, a00(75, 0), console.log('Creating zip from source files'));
                    }
                    _context.next = 13;
                    return a00(75, 2, a00(75, 0), (0, _zip.zip)(_filesSrc, cwd));
                  case 13:
                    zipped = _context.sent;
                    _context.next = 21;
                    break;
                  case 16:
                    if (!sources) {
                      _context.next = 21;
                      break;
                    }
                    if (debug) {
                      a00(75, 2, a00(75, 0), console.log('Creating zip from sources'));
                    }
                    _context.next = 20;
                    return a00(75, 2, a00(75, 0), (0, _zip.zipSources)(sources));
                  case 20:
                    zipped = _context.sent;
                  case 21:
                    if (!zipped) {
                      _context.next = 30;
                      break;
                    }
                    content = a00(75, 2, a00(75, 0), a00(75, 2, a00(75, 0), zipped.generate({
                      type: 'nodebuffer'
                    })).toString('base64'));
                    if (debug) {
                      a00(75, 2, a00(75, 0), console.log('Adding sources to application'));
                    }
                    source = {
                      content: content,
                      filename: 'application.zip',
                      extension: 'zip'
                    };
                    _context.t0 = errorHandler;
                    _context.next = 28;
                    return a00(75, 2, a00(75, 0), this.addApplicationSource(client, applicationId, source));
                  case 28:
                    _context.t1 = _context.sent;
                    a00(75, 2, a00(75, 0), (0, _context.t0)(_context.t1));
                  case 30:
                    return a00(75, 2, a00(75, 0), _context.abrupt('return', source));
                  case 31:
                  case 'end':
                    return a00(75, 2, a00(75, 0), _context.stop());
                }
              }
            } finally {
              a00(75, 0);
            }
          }, _callee, this));
        } finally {
          a00(74, 0);
        }
      })));
      function updateApplicationSources(_x, _x2, _x3) {
        try {
          a00(76, 1);
          return a00(76, 2, a00(76, 0), _ref2.apply(this, arguments));
        } finally {
          a00(76, 0);
        }
      }
      return updateApplicationSources;
    } finally {
      a00(73, 0);
    }
  })()),
  protectAndDownload: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(77, 1);
      var _ref3 = a00(77, 2, a00(77, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee2(configPathOrObject, destCallback) {
        try {
          a00(78, 1);
          var _config, finalConfig, applicationId, host, port, protocol, cafile, keys, sources, _finalConfig$stream, stream, cwd, params, applicationTypes, languageSpecifications, sourceMaps, randomizationSeed, areSubscribersOrdered, useRecommendedOrder, _finalConfig$bail, bail, jscramblerVersion, debugMode, proxy, clientId, tolerateMinification, codeHardeningThreshold, useProfilingData, browsers, useAppClassification, accessKey, secretKey, client, filesSrc, filesDest, source, updateData, applicationUpdate, updateApplicationRes, createApplicationProtectionRes, protectionId, protection, sourcesErrors, download;
          return a00(78, 2, a00(78, 0), regeneratorRuntime.wrap(function _callee2$(_context2) {
            try {
              a00(79, 1);
              while (1) {
                a00(79, -1);
                switch (_context2.prev = _context2.next) {
                  case 0:
                    _config = typeof configPathOrObject === 'string' ? require(configPathOrObject) : configPathOrObject;
                    finalConfig = a00(79, 2, a00(79, 0), (0, _lodash2.default)(_config, _config3.default));
                    (applicationId = finalConfig.applicationId, host = finalConfig.host, port = finalConfig.port, protocol = finalConfig.protocol, cafile = finalConfig.cafile, keys = finalConfig.keys, sources = finalConfig.sources, _finalConfig$stream = finalConfig.stream, stream = _finalConfig$stream === undefined ? true : _finalConfig$stream, cwd = finalConfig.cwd, params = finalConfig.params, applicationTypes = finalConfig.applicationTypes, languageSpecifications = finalConfig.languageSpecifications, sourceMaps = finalConfig.sourceMaps, randomizationSeed = finalConfig.randomizationSeed, areSubscribersOrdered = finalConfig.areSubscribersOrdered, useRecommendedOrder = finalConfig.useRecommendedOrder, _finalConfig$bail = finalConfig.bail, bail = _finalConfig$bail === undefined ? true : _finalConfig$bail, jscramblerVersion = finalConfig.jscramblerVersion, debugMode = finalConfig.debugMode, proxy = finalConfig.proxy, clientId = finalConfig.clientId, tolerateMinification = finalConfig.tolerateMinification, codeHardeningThreshold = finalConfig.codeHardeningThreshold, useProfilingData = finalConfig.useProfilingData, browsers = finalConfig.browsers, useAppClassification = finalConfig.useAppClassification);
                    (accessKey = keys.accessKey, secretKey = keys.secretKey);
                    client = new this.Client({
                      accessKey: accessKey,
                      secretKey: secretKey,
                      host: host,
                      port: port,
                      protocol: protocol,
                      cafile: cafile,
                      jscramblerVersion: jscramblerVersion,
                      proxy: proxy,
                      clientId: clientId
                    });
                    filesSrc = finalConfig.filesSrc;
                    filesDest = finalConfig.filesDest;
                    if (sources) {
                      filesSrc = undefined;
                    }
                    if (destCallback) {
                      filesDest = undefined;
                    }
                    if (applicationId) {
                      _context2.next = 11;
                      break;
                    }
                    throw new Error('Required *applicationId* not provided');
                  case 11:
                    if (!(!filesDest && !destCallback)) {
                      _context2.next = 13;
                      break;
                    }
                    throw new Error('Required *filesDest* not provided');
                  case 13:
                    _context2.next = 15;
                    return a00(79, 2, a00(79, 0), this.updateApplicationSources(client, applicationId, {
                      sources: sources,
                      filesSrc: filesSrc,
                      cwd: cwd
                    }));
                  case 15:
                    source = _context2.sent;
                    updateData = {
                      _id: applicationId,
                      debugMode: ! !debugMode,
                      tolerateMinification: tolerateMinification,
                      codeHardeningThreshold: codeHardeningThreshold
                    };
                    if (params && a00(79, 2, a00(79, 0), Object.keys(params)).length) {
                      updateData.parameters = a00(79, 2, a00(79, 0), normalizeParameters(params));
                      updateData.areSubscribersOrdered = a00(79, 2, a00(79, 0), Array.isArray(params));
                    }
                    if (typeof areSubscribersOrdered !== 'undefined') {
                      updateData.areSubscribersOrdered = areSubscribersOrdered;
                    }
                    if (applicationTypes) {
                      updateData.applicationTypes = applicationTypes;
                    }
                    if (typeof useRecommendedOrder !== 'undefined') {
                      updateData.useRecommendedOrder = useRecommendedOrder;
                    }
                    if (languageSpecifications) {
                      updateData.languageSpecifications = languageSpecifications;
                    }
                    if (typeof sourceMaps !== 'undefined') {
                      updateData.sourceMaps = sourceMaps;
                    }
                    if (useProfilingData !== undefined) {
                      updateData.useProfilingData = useProfilingData;
                    }
                    if (useAppClassification !== undefined) {
                      updateData.useAppClassification = useAppClassification;
                    }
                    if (browsers) {
                      updateData.browsers = browsers;
                    }
                    if (!(updateData.parameters || updateData.applicationTypes || updateData.languageSpecifications || updateData.browsers || typeof updateData.areSubscribersOrdered !== 'undefined')) {
                      _context2.next = 36;
                      break;
                    }
                    if (debug) {
                      a00(79, 2, a00(79, 0), console.log('Updating parameters of protection'));
                    }
                    _context2.next = 30;
                    return a00(79, 2, a00(79, 0), intoObjectType(client, updateData, 'Application'));
                  case 30:
                    applicationUpdate = _context2.sent;
                    _context2.next = 33;
                    return a00(79, 2, a00(79, 0), this.updateApplication(client, applicationUpdate));
                  case 33:
                    updateApplicationRes = _context2.sent;
                    if (debug) {
                      a00(79, 2, a00(79, 0), console.log('Finished updating parameters of protection'));
                      a00(79, 2, a00(79, 0), console.error(updateApplicationRes));
                    }
                    a00(79, 2, a00(79, 0), errorHandler(updateApplicationRes));
                  case 36:
                    if (debug) {
                      a00(79, 2, a00(79, 0), console.log('Creating Application Protection'));
                    }
                    delete updateData._id;
                    _context2.next = 40;
                    return a00(79, 2, a00(79, 0), this.createApplicationProtection(client, applicationId, Object.assign({
                      bail: bail,
                      randomizationSeed: randomizationSeed,
                      tolerateMinification: tolerateMinification,
                      source: source
                    }, updateData)));
                  case 40:
                    createApplicationProtectionRes = _context2.sent;
                    a00(79, 2, a00(79, 0), errorHandler(createApplicationProtectionRes));
                    protectionId = createApplicationProtectionRes.data.createApplicationProtection._id;
                    _context2.t0 = this;
                    _context2.t1 = client;
                    _context2.t2 = applicationId;
                    _context2.t3 = protectionId;
                    _context2.next = 49;
                    return a00(79, 2, a00(79, 0), (0, _getProtectionDefaultFragments2.default)(client));
                  case 49:
                    _context2.t4 = _context2.sent;
                    _context2.next = 52;
                    return a00(79, 2, a00(79, 0), _context2.t0.pollProtection.call(_context2.t0, _context2.t1, _context2.t2, _context2.t3, _context2.t4));
                  case 52:
                    protection = _context2.sent;
                    if (protection.growthWarning) {
                      a00(79, 2, a00(79, 0), console.warn('Warning: Your protected application has surpassed a reasonable file growth.\nFor more information on what might have caused this, please see the Protection Report.\nLink: ' + APP_URL + '.'));
                    }
                    if (debug) {
                      a00(79, 2, a00(79, 0), console.log('Finished protecting'));
                    }
                    if (protection.deprecations) {
                      a00(79, 2, a00(79, 0), protection.deprecations.forEach(function (deprecation) {
                        try {
                          a00(80, 1);
                          if (deprecation.type === 'Transformation') {
                            a00(80, 2, a00(80, 0), console.warn('Warning: ' + deprecation.type + ' ' + deprecation.entity + ' is no longer maintained. Please consider removing it from your configuration.'));
                          } else if (deprecation.type && deprecation.entity) {
                            a00(80, 2, a00(80, 0), console.warn('Warning: ' + deprecation.type + ' ' + deprecation.entity + ' is deprecated.'));
                          }
                        } finally {
                          a00(80, 0);
                        }
                      }));
                    }
                    sourcesErrors = [];
                    a00(79, 2, a00(79, 0), protection.sources.forEach(function (s) {
                      try {
                        a00(81, 1);
                        if (s.errorMessages && s.errorMessages.length > 0) {
                          a00(81, 2, a00(81, 0), sourcesErrors.push.apply(sourcesErrors, _toConsumableArray(s.errorMessages.map(function (e) {
                            try {
                              a00(82, 1);
                              return a00(82, 2, a00(82, 0), Object.assign({
                                filename: s.filename
                              }, e));
                            } finally {
                              a00(82, 0);
                            }
                          }))));
                        }
                      } finally {
                        a00(81, 0);
                      }
                    }));
                    if (!(protection.state === 'errored')) {
                      _context2.next = 66;
                      break;
                    }
                    a00(79, 2, a00(79, 0), console.error('Global protection errors:'));
                    a00(79, 2, a00(79, 0), console.error('- ' + protection.errorMessage));
                    a00(79, 2, a00(79, 0), console.error(''));
                    if (sourcesErrors.length > 0) {
                      a00(79, 2, a00(79, 0), printSourcesErrors(sourcesErrors));
                    }
                    throw new Error('Protection failed. For more information visit: ' + APP_URL + '.');
                  case 66:
                    if (!(sourcesErrors.length > 0)) {
                      _context2.next = 73;
                      break;
                    }
                    if (!protection.bail) {
                      _context2.next = 72;
                      break;
                    }
                    a00(79, 2, a00(79, 0), printSourcesErrors(sourcesErrors));
                    throw new Error('Your protection has failed.');
                  case 72:
                    a00(79, 2, a00(79, 0), sourcesErrors.forEach(function (e) {
                      try {
                        a00(83, 1);
                        return a00(83, 2, a00(83, 0), console.warn('Non-fatal error: "' + e.message + '" in ' + e.filename));
                      } finally {
                        a00(83, 0);
                      }
                    }));
                  case 73:
                    if (debug) {
                      a00(79, 2, a00(79, 0), console.log('Downloading protection result'));
                    }
                    _context2.next = 76;
                    return a00(79, 2, a00(79, 0), this.downloadApplicationProtection(client, protectionId));
                  case 76:
                    download = _context2.sent;
                    a00(79, 2, a00(79, 0), errorHandler(download));
                    if (debug) {
                      a00(79, 2, a00(79, 0), console.log('Unzipping files'));
                    }
                    a00(79, 2, a00(79, 0), (0, _zip.unzip)(download, filesDest || destCallback, stream));
                    if (debug) {
                      a00(79, 2, a00(79, 0), console.log('Finished unzipping files'));
                    }
                    a00(79, 2, a00(79, 0), console.log(protectionId));
                    return a00(79, 2, a00(79, 0), _context2.abrupt('return', protectionId));
                  case 83:
                  case 'end':
                    return a00(79, 2, a00(79, 0), _context2.stop());
                }
              }
            } finally {
              a00(79, 0);
            }
          }, _callee2, this));
        } finally {
          a00(78, 0);
        }
      })));
      function protectAndDownload(_x4, _x5) {
        try {
          a00(84, 1);
          return a00(84, 2, a00(84, 0), _ref3.apply(this, arguments));
        } finally {
          a00(84, 0);
        }
      }
      return protectAndDownload;
    } finally {
      a00(77, 0);
    }
  })()),
  instrumentAndDownload: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(85, 1);
      var _ref4 = a00(85, 2, a00(85, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee3(configPathOrObject, destCallback) {
        try {
          a00(86, 1);
          var _config, finalConfig, applicationId, host, port, protocol, cafile, keys, sources, _finalConfig$stream2, stream, cwd, jscramblerVersion, proxy, clientId, accessKey, secretKey, client, filesSrc, filesDest, instrumentation, download;
          return a00(86, 2, a00(86, 0), regeneratorRuntime.wrap(function _callee3$(_context3) {
            try {
              a00(87, 1);
              while (1) {
                a00(87, -1);
                switch (_context3.prev = _context3.next) {
                  case 0:
                    _config = typeof configPathOrObject === 'string' ? require(configPathOrObject) : configPathOrObject;
                    finalConfig = a00(87, 2, a00(87, 0), (0, _lodash2.default)(_config, _config3.default));
                    (applicationId = finalConfig.applicationId, host = finalConfig.host, port = finalConfig.port, protocol = finalConfig.protocol, cafile = finalConfig.cafile, keys = finalConfig.keys, sources = finalConfig.sources, _finalConfig$stream2 = finalConfig.stream, stream = _finalConfig$stream2 === undefined ? true : _finalConfig$stream2, cwd = finalConfig.cwd, jscramblerVersion = finalConfig.jscramblerVersion, proxy = finalConfig.proxy, clientId = finalConfig.clientId);
                    (accessKey = keys.accessKey, secretKey = keys.secretKey);
                    client = new this.Client({
                      accessKey: accessKey,
                      secretKey: secretKey,
                      host: host,
                      port: port,
                      protocol: protocol,
                      cafile: cafile,
                      jscramblerVersion: jscramblerVersion,
                      proxy: proxy,
                      clientId: clientId
                    });
                    (filesSrc = finalConfig.filesSrc, filesDest = finalConfig.filesDest);
                    if (sources) {
                      filesSrc = undefined;
                    }
                    if (destCallback) {
                      filesDest = undefined;
                    }
                    if (applicationId) {
                      _context3.next = 10;
                      break;
                    }
                    throw new Error('Required *applicationId* not provided');
                  case 10:
                    if (!(!filesDest && !destCallback)) {
                      _context3.next = 12;
                      break;
                    }
                    throw new Error('Required *filesDest* not provided');
                  case 12:
                    _context3.next = 14;
                    return a00(87, 2, a00(87, 0), this.updateApplicationSources(client, applicationId, {
                      sources: sources,
                      filesSrc: filesSrc,
                      cwd: cwd
                    }));
                  case 14:
                    _context3.next = 16;
                    return a00(87, 2, a00(87, 0), this.startInstrumentation(client, applicationId));
                  case 16:
                    instrumentation = _context3.sent;
                    a00(87, 2, a00(87, 0), errorHandler(instrumentation));
                    _context3.next = 20;
                    return a00(87, 2, a00(87, 0), this.pollInstrumentation(client, instrumentation.data.id));
                  case 20:
                    instrumentation = _context3.sent;
                    if (debug) {
                      a00(87, 2, a00(87, 0), console.log('Finished instrumention with id ' + instrumentation.data.id + '. Downloading...'));
                    }
                    _context3.next = 24;
                    return a00(87, 2, a00(87, 0), this.downloadApplicationInstrumented(client, instrumentation.data.id));
                  case 24:
                    download = _context3.sent;
                    a00(87, 2, a00(87, 0), errorHandler(download));
                    if (debug) {
                      a00(87, 2, a00(87, 0), console.log('Unzipping files'));
                    }
                    a00(87, 2, a00(87, 0), (0, _zip.unzip)(download, filesDest || destCallback, stream));
                    if (debug) {
                      a00(87, 2, a00(87, 0), console.log('Finished unzipping files'));
                    }
                    a00(87, 2, a00(87, 0), console.log('Application ' + applicationId + ' was instrumented. Bootstrap your application, go to ' + APP_URL + ' and start profiling!'));
                    return a00(87, 2, a00(87, 0), _context3.abrupt('return', instrumentation.data.id));
                  case 31:
                  case 'end':
                    return a00(87, 2, a00(87, 0), _context3.stop());
                }
              }
            } finally {
              a00(87, 0);
            }
          }, _callee3, this));
        } finally {
          a00(86, 0);
        }
      })));
      function instrumentAndDownload(_x6, _x7) {
        try {
          a00(88, 1);
          return a00(88, 2, a00(88, 0), _ref4.apply(this, arguments));
        } finally {
          a00(88, 0);
        }
      }
      return instrumentAndDownload;
    } finally {
      a00(85, 0);
    }
  })()),
  downloadSourceMaps: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(89, 1);
      var _ref5 = a00(89, 2, a00(89, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee4(configs, destCallback) {
        try {
          a00(90, 1);
          var keys, host, port, protocol, cafile, _configs$stream, stream, filesDest, filesSrc, protectionId, proxy, accessKey, secretKey, client, download;
          return a00(90, 2, a00(90, 0), regeneratorRuntime.wrap(function _callee4$(_context4) {
            try {
              a00(91, 1);
              while (1) {
                a00(91, -1);
                switch (_context4.prev = _context4.next) {
                  case 0:
                    (keys = configs.keys, host = configs.host, port = configs.port, protocol = configs.protocol, cafile = configs.cafile, _configs$stream = configs.stream, stream = _configs$stream === undefined ? true : _configs$stream, filesDest = configs.filesDest, filesSrc = configs.filesSrc, protectionId = configs.protectionId, proxy = configs.proxy);
                    (accessKey = keys.accessKey, secretKey = keys.secretKey);
                    client = new this.Client({
                      accessKey: accessKey,
                      secretKey: secretKey,
                      host: host,
                      port: port,
                      protocol: protocol,
                      cafile: cafile,
                      proxy: proxy
                    });
                    if (!(!filesDest && !destCallback)) {
                      _context4.next = 5;
                      break;
                    }
                    throw new Error('Required *filesDest* not provided');
                  case 5:
                    if (protectionId) {
                      _context4.next = 7;
                      break;
                    }
                    throw new Error('Required *protectionId* not provided');
                  case 7:
                    if (filesSrc) {
                      a00(91, 2, a00(91, 0), console.warn('[Warning] Ignoring sources supplied. Downloading source maps of given protection'));
                    }
                    download = void 0;
                    _context4.prev = 9;
                    _context4.next = 12;
                    return a00(91, 2, a00(91, 0), this.downloadSourceMapsRequest(client, protectionId));
                  case 12:
                    download = _context4.sent;
                    _context4.next = 18;
                    break;
                  case 15:
                    _context4.prev = 15;
                    _context4.t0 = a00(91, 2, a00(91, 0), _context4['catch'](9));
                    a00(91, 2, a00(91, 0), errorHandler(_context4.t0));
                  case 18:
                    a00(91, 2, a00(91, 0), (0, _zip.unzip)(download, filesDest || destCallback, stream));
                  case 19:
                  case 'end':
                    return a00(91, 2, a00(91, 0), _context4.stop());
                }
              }
            } finally {
              a00(91, 0);
            }
          }, _callee4, this, [[9, 15]]));
        } finally {
          a00(90, 0);
        }
      })));
      function downloadSourceMaps(_x8, _x9) {
        try {
          a00(92, 1);
          return a00(92, 2, a00(92, 0), _ref5.apply(this, arguments));
        } finally {
          a00(92, 0);
        }
      }
      return downloadSourceMaps;
    } finally {
      a00(89, 0);
    }
  })()),
  pollInstrumentation: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(93, 1);
      var _ref6 = a00(93, 2, a00(93, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee6(client, instrumentationId) {
        try {
          a00(94, 1);
          var _this = this;
          var poll;
          return a00(94, 2, a00(94, 0), regeneratorRuntime.wrap(function _callee6$(_context6) {
            try {
              a00(95, 1);
              while (1) {
                a00(95, -1);
                switch (_context6.prev = _context6.next) {
                  case 0:
                    poll = a00(95, 2, a00(95, 0), (function () {
                      try {
                        a00(96, 1);
                        var _ref7 = a00(96, 2, a00(96, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee5() {
                          try {
                            a00(97, 1);
                            var instrumentation;
                            return a00(97, 2, a00(97, 0), regeneratorRuntime.wrap(function _callee5$(_context5) {
                              try {
                                a00(98, 1);
                                while (1) {
                                  a00(98, -1);
                                  switch (_context5.prev = _context5.next) {
                                    case 0:
                                      _context5.next = 2;
                                      return a00(98, 2, a00(98, 0), _this.getInstrumentation(client, instrumentationId));
                                    case 2:
                                      instrumentation = _context5.sent;
                                      _context5.t0 = instrumentation.data.state;
                                      _context5.next = _context5.t0 === 'DELETED' ? 6 : _context5.t0 === 'FAILED_INSTRUMENTATION' ? 7 : _context5.t0 === 'FINISHED_INSTRUMENTATION' ? 9 : 10;
                                      break;
                                    case 6:
                                      throw new Error('Protection canceled by user');
                                    case 7:
                                      instrumentation.errors = a00(98, 2, a00(98, 0), instrumentation.errors.concat(instrumentation.data.instrumentationErrors.map(function (e) {
                                        try {
                                          a00(99, 1);
                                          return {
                                            message: e.message + ' at ' + e.fileName + ':' + e.lineNumber
                                          };
                                        } finally {
                                          a00(99, 0);
                                        }
                                      })));
                                      return a00(98, 2, a00(98, 0), _context5.abrupt('return', errorHandler(instrumentation)));
                                    case 9:
                                      return a00(98, 2, a00(98, 0), _context5.abrupt('return', instrumentation));
                                    case 10:
                                      _context5.next = 12;
                                      return new Promise(function (resolve) {
                                        try {
                                          a00(100, 1);
                                          return a00(100, 2, a00(100, 0), setTimeout(resolve, 500));
                                        } finally {
                                          a00(100, 0);
                                        }
                                      });
                                    case 12:
                                      return a00(98, 2, a00(98, 0), _context5.abrupt('return', poll()));
                                    case 13:
                                    case 'end':
                                      return a00(98, 2, a00(98, 0), _context5.stop());
                                  }
                                }
                              } finally {
                                a00(98, 0);
                              }
                            }, _callee5, _this));
                          } finally {
                            a00(97, 0);
                          }
                        })));
                        return function poll() {
                          try {
                            a00(101, 1);
                            return a00(101, 2, a00(101, 0), _ref7.apply(this, arguments));
                          } finally {
                            a00(101, 0);
                          }
                        };
                      } finally {
                        a00(96, 0);
                      }
                    })());
                    return a00(95, 2, a00(95, 0), _context6.abrupt('return', poll()));
                  case 2:
                  case 'end':
                    return a00(95, 2, a00(95, 0), _context6.stop());
                }
              }
            } finally {
              a00(95, 0);
            }
          }, _callee6, this));
        } finally {
          a00(94, 0);
        }
      })));
      function pollInstrumentation(_x10, _x11) {
        try {
          a00(102, 1);
          return a00(102, 2, a00(102, 0), _ref6.apply(this, arguments));
        } finally {
          a00(102, 0);
        }
      }
      return pollInstrumentation;
    } finally {
      a00(93, 0);
    }
  })()),
  pollProtection: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(103, 1);
      var _ref8 = a00(103, 2, a00(103, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee8(client, applicationId, protectionId, fragments) {
        try {
          a00(104, 1);
          var _this2 = this;
          var poll;
          return a00(104, 2, a00(104, 0), regeneratorRuntime.wrap(function _callee8$(_context8) {
            try {
              a00(105, 1);
              while (1) {
                a00(105, -1);
                switch (_context8.prev = _context8.next) {
                  case 0:
                    poll = a00(105, 2, a00(105, 0), (function () {
                      try {
                        a00(106, 1);
                        var _ref9 = a00(106, 2, a00(106, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee7() {
                          try {
                            a00(107, 1);
                            var applicationProtection, state;
                            return a00(107, 2, a00(107, 0), regeneratorRuntime.wrap(function _callee7$(_context7) {
                              try {
                                a00(108, 1);
                                while (1) {
                                  a00(108, -1);
                                  switch (_context7.prev = _context7.next) {
                                    case 0:
                                      _context7.next = 2;
                                      return a00(108, 2, a00(108, 0), _this2.getApplicationProtection(client, applicationId, protectionId, fragments));
                                    case 2:
                                      applicationProtection = _context7.sent;
                                      if (!applicationProtection.errors) {
                                        _context7.next = 8;
                                        break;
                                      }
                                      a00(108, 2, a00(108, 0), console.log('Error polling protection', applicationProtection.errors));
                                      throw new Error('Protection failed. For more information visit: ' + APP_URL + '.');
                                    case 8:
                                      state = applicationProtection.data.applicationProtection.state;
                                      if (!(state !== 'finished' && state !== 'errored' && state !== 'canceled')) {
                                        _context7.next = 15;
                                        break;
                                      }
                                      _context7.next = 12;
                                      return new Promise(function (resolve) {
                                        try {
                                          a00(109, 1);
                                          return a00(109, 2, a00(109, 0), setTimeout(resolve, 500));
                                        } finally {
                                          a00(109, 0);
                                        }
                                      });
                                    case 12:
                                      return a00(108, 2, a00(108, 0), _context7.abrupt('return', poll()));
                                    case 15:
                                      if (!(state === 'canceled')) {
                                        _context7.next = 19;
                                        break;
                                      }
                                      throw new Error('Protection canceled by user');
                                    case 19:
                                      return a00(108, 2, a00(108, 0), _context7.abrupt('return', applicationProtection.data.applicationProtection));
                                    case 20:
                                    case 'end':
                                      return a00(108, 2, a00(108, 0), _context7.stop());
                                  }
                                }
                              } finally {
                                a00(108, 0);
                              }
                            }, _callee7, _this2));
                          } finally {
                            a00(107, 0);
                          }
                        })));
                        return function poll() {
                          try {
                            a00(110, 1);
                            return a00(110, 2, a00(110, 0), _ref9.apply(this, arguments));
                          } finally {
                            a00(110, 0);
                          }
                        };
                      } finally {
                        a00(106, 0);
                      }
                    })());
                    return a00(105, 2, a00(105, 0), _context8.abrupt('return', poll()));
                  case 2:
                  case 'end':
                    return a00(105, 2, a00(105, 0), _context8.stop());
                }
              }
            } finally {
              a00(105, 0);
            }
          }, _callee8, this));
        } finally {
          a00(104, 0);
        }
      })));
      function pollProtection(_x12, _x13, _x14, _x15) {
        try {
          a00(111, 1);
          return a00(111, 2, a00(111, 0), _ref8.apply(this, arguments));
        } finally {
          a00(111, 0);
        }
      }
      return pollProtection;
    } finally {
      a00(103, 0);
    }
  })()),
  createApplication: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(112, 1);
      var _ref10 = a00(112, 2, a00(112, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee9(client, data, fragments) {
        try {
          a00(113, 1);
          return a00(113, 2, a00(113, 0), regeneratorRuntime.wrap(function _callee9$(_context9) {
            try {
              a00(114, 1);
              while (1) {
                a00(114, -1);
                switch (_context9.prev = _context9.next) {
                  case 0:
                    return a00(114, 2, a00(114, 0), _context9.abrupt('return', client.post('/application', mutations.createApplication(data, fragments))));
                  case 1:
                  case 'end':
                    return a00(114, 2, a00(114, 0), _context9.stop());
                }
              }
            } finally {
              a00(114, 0);
            }
          }, _callee9, this));
        } finally {
          a00(113, 0);
        }
      })));
      function createApplication(_x16, _x17, _x18) {
        try {
          a00(115, 1);
          return a00(115, 2, a00(115, 0), _ref10.apply(this, arguments));
        } finally {
          a00(115, 0);
        }
      }
      return createApplication;
    } finally {
      a00(112, 0);
    }
  })()),
  duplicateApplication: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(116, 1);
      var _ref11 = a00(116, 2, a00(116, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee10(client, data, fragments) {
        try {
          a00(117, 1);
          return a00(117, 2, a00(117, 0), regeneratorRuntime.wrap(function _callee10$(_context10) {
            try {
              a00(118, 1);
              while (1) {
                a00(118, -1);
                switch (_context10.prev = _context10.next) {
                  case 0:
                    return a00(118, 2, a00(118, 0), _context10.abrupt('return', client.post('/application', mutations.duplicateApplication(data, fragments))));
                  case 1:
                  case 'end':
                    return a00(118, 2, a00(118, 0), _context10.stop());
                }
              }
            } finally {
              a00(118, 0);
            }
          }, _callee10, this));
        } finally {
          a00(117, 0);
        }
      })));
      function duplicateApplication(_x19, _x20, _x21) {
        try {
          a00(119, 1);
          return a00(119, 2, a00(119, 0), _ref11.apply(this, arguments));
        } finally {
          a00(119, 0);
        }
      }
      return duplicateApplication;
    } finally {
      a00(116, 0);
    }
  })()),
  removeApplication: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(120, 1);
      var _ref12 = a00(120, 2, a00(120, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee11(client, id) {
        try {
          a00(121, 1);
          return a00(121, 2, a00(121, 0), regeneratorRuntime.wrap(function _callee11$(_context11) {
            try {
              a00(122, 1);
              while (1) {
                a00(122, -1);
                switch (_context11.prev = _context11.next) {
                  case 0:
                    return a00(122, 2, a00(122, 0), _context11.abrupt('return', client.post('/application', mutations.removeApplication(id))));
                  case 1:
                  case 'end':
                    return a00(122, 2, a00(122, 0), _context11.stop());
                }
              }
            } finally {
              a00(122, 0);
            }
          }, _callee11, this));
        } finally {
          a00(121, 0);
        }
      })));
      function removeApplication(_x22, _x23) {
        try {
          a00(123, 1);
          return a00(123, 2, a00(123, 0), _ref12.apply(this, arguments));
        } finally {
          a00(123, 0);
        }
      }
      return removeApplication;
    } finally {
      a00(120, 0);
    }
  })()),
  removeProtection: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(124, 1);
      var _ref13 = a00(124, 2, a00(124, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee12(client, id, appId, fragments) {
        try {
          a00(125, 1);
          return a00(125, 2, a00(125, 0), regeneratorRuntime.wrap(function _callee12$(_context12) {
            try {
              a00(126, 1);
              while (1) {
                a00(126, -1);
                switch (_context12.prev = _context12.next) {
                  case 0:
                    return a00(126, 2, a00(126, 0), _context12.abrupt('return', client.post('/application', mutations.removeProtection(id, appId, fragments))));
                  case 1:
                  case 'end':
                    return a00(126, 2, a00(126, 0), _context12.stop());
                }
              }
            } finally {
              a00(126, 0);
            }
          }, _callee12, this));
        } finally {
          a00(125, 0);
        }
      })));
      function removeProtection(_x24, _x25, _x26, _x27) {
        try {
          a00(127, 1);
          return a00(127, 2, a00(127, 0), _ref13.apply(this, arguments));
        } finally {
          a00(127, 0);
        }
      }
      return removeProtection;
    } finally {
      a00(124, 0);
    }
  })()),
  cancelProtection: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(128, 1);
      var _ref14 = a00(128, 2, a00(128, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee13(client, id, appId, fragments) {
        try {
          a00(129, 1);
          var mutation;
          return a00(129, 2, a00(129, 0), regeneratorRuntime.wrap(function _callee13$(_context13) {
            try {
              a00(130, 1);
              while (1) {
                a00(130, -1);
                switch (_context13.prev = _context13.next) {
                  case 0:
                    _context13.next = 2;
                    return a00(130, 2, a00(130, 0), mutations.cancelProtection(id, appId, fragments));
                  case 2:
                    mutation = _context13.sent;
                    return a00(130, 2, a00(130, 0), _context13.abrupt('return', client.post('/application', mutation)));
                  case 4:
                  case 'end':
                    return a00(130, 2, a00(130, 0), _context13.stop());
                }
              }
            } finally {
              a00(130, 0);
            }
          }, _callee13, this));
        } finally {
          a00(129, 0);
        }
      })));
      function cancelProtection(_x28, _x29, _x30, _x31) {
        try {
          a00(131, 1);
          return a00(131, 2, a00(131, 0), _ref14.apply(this, arguments));
        } finally {
          a00(131, 0);
        }
      }
      return cancelProtection;
    } finally {
      a00(128, 0);
    }
  })()),
  updateApplication: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(132, 1);
      var _ref15 = a00(132, 2, a00(132, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee14(client, application, fragments) {
        try {
          a00(133, 1);
          var mutation;
          return a00(133, 2, a00(133, 0), regeneratorRuntime.wrap(function _callee14$(_context14) {
            try {
              a00(134, 1);
              while (1) {
                a00(134, -1);
                switch (_context14.prev = _context14.next) {
                  case 0:
                    _context14.next = 2;
                    return a00(134, 2, a00(134, 0), mutations.updateApplication(application, fragments));
                  case 2:
                    mutation = _context14.sent;
                    return a00(134, 2, a00(134, 0), _context14.abrupt('return', client.post('/application', mutation)));
                  case 4:
                  case 'end':
                    return a00(134, 2, a00(134, 0), _context14.stop());
                }
              }
            } finally {
              a00(134, 0);
            }
          }, _callee14, this));
        } finally {
          a00(133, 0);
        }
      })));
      function updateApplication(_x32, _x33, _x34) {
        try {
          a00(135, 1);
          return a00(135, 2, a00(135, 0), _ref15.apply(this, arguments));
        } finally {
          a00(135, 0);
        }
      }
      return updateApplication;
    } finally {
      a00(132, 0);
    }
  })()),
  unlockApplication: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(136, 1);
      var _ref16 = a00(136, 2, a00(136, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee15(client, application, fragments) {
        try {
          a00(137, 1);
          var mutation;
          return a00(137, 2, a00(137, 0), regeneratorRuntime.wrap(function _callee15$(_context15) {
            try {
              a00(138, 1);
              while (1) {
                a00(138, -1);
                switch (_context15.prev = _context15.next) {
                  case 0:
                    _context15.next = 2;
                    return a00(138, 2, a00(138, 0), mutations.unlockApplication(application, fragments));
                  case 2:
                    mutation = _context15.sent;
                    return a00(138, 2, a00(138, 0), _context15.abrupt('return', client.post('/application', mutation)));
                  case 4:
                  case 'end':
                    return a00(138, 2, a00(138, 0), _context15.stop());
                }
              }
            } finally {
              a00(138, 0);
            }
          }, _callee15, this));
        } finally {
          a00(137, 0);
        }
      })));
      function unlockApplication(_x35, _x36, _x37) {
        try {
          a00(139, 1);
          return a00(139, 2, a00(139, 0), _ref16.apply(this, arguments));
        } finally {
          a00(139, 0);
        }
      }
      return unlockApplication;
    } finally {
      a00(136, 0);
    }
  })()),
  getApplication: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(140, 1);
      var _ref17 = a00(140, 2, a00(140, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee16(client, applicationId, fragments, params) {
        try {
          a00(141, 1);
          var query;
          return a00(141, 2, a00(141, 0), regeneratorRuntime.wrap(function _callee16$(_context16) {
            try {
              a00(142, 1);
              while (1) {
                a00(142, -1);
                switch (_context16.prev = _context16.next) {
                  case 0:
                    _context16.next = 2;
                    return a00(142, 2, a00(142, 0), queries.getApplication(applicationId, fragments, params));
                  case 2:
                    query = _context16.sent;
                    return a00(142, 2, a00(142, 0), _context16.abrupt('return', client.get('/application', query)));
                  case 4:
                  case 'end':
                    return a00(142, 2, a00(142, 0), _context16.stop());
                }
              }
            } finally {
              a00(142, 0);
            }
          }, _callee16, this));
        } finally {
          a00(141, 0);
        }
      })));
      function getApplication(_x38, _x39, _x40, _x41) {
        try {
          a00(143, 1);
          return a00(143, 2, a00(143, 0), _ref17.apply(this, arguments));
        } finally {
          a00(143, 0);
        }
      }
      return getApplication;
    } finally {
      a00(140, 0);
    }
  })()),
  getApplicationSource: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(144, 1);
      var _ref18 = a00(144, 2, a00(144, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee17(client, sourceId, fragments, limits) {
        try {
          a00(145, 1);
          var query;
          return a00(145, 2, a00(145, 0), regeneratorRuntime.wrap(function _callee17$(_context17) {
            try {
              a00(146, 1);
              while (1) {
                a00(146, -1);
                switch (_context17.prev = _context17.next) {
                  case 0:
                    _context17.next = 2;
                    return a00(146, 2, a00(146, 0), queries.getApplicationSource(sourceId, fragments, limits));
                  case 2:
                    query = _context17.sent;
                    return a00(146, 2, a00(146, 0), _context17.abrupt('return', client.get('/application', query)));
                  case 4:
                  case 'end':
                    return a00(146, 2, a00(146, 0), _context17.stop());
                }
              }
            } finally {
              a00(146, 0);
            }
          }, _callee17, this));
        } finally {
          a00(145, 0);
        }
      })));
      function getApplicationSource(_x42, _x43, _x44, _x45) {
        try {
          a00(147, 1);
          return a00(147, 2, a00(147, 0), _ref18.apply(this, arguments));
        } finally {
          a00(147, 0);
        }
      }
      return getApplicationSource;
    } finally {
      a00(144, 0);
    }
  })()),
  getApplicationProtections: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(148, 1);
      var _ref19 = a00(148, 2, a00(148, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee18(client, applicationId, params, fragments) {
        try {
          a00(149, 1);
          var query;
          return a00(149, 2, a00(149, 0), regeneratorRuntime.wrap(function _callee18$(_context18) {
            try {
              a00(150, 1);
              while (1) {
                a00(150, -1);
                switch (_context18.prev = _context18.next) {
                  case 0:
                    _context18.next = 2;
                    return a00(150, 2, a00(150, 0), queries.getApplicationProtections(applicationId, params, fragments));
                  case 2:
                    query = _context18.sent;
                    return a00(150, 2, a00(150, 0), _context18.abrupt('return', client.get('/application', query)));
                  case 4:
                  case 'end':
                    return a00(150, 2, a00(150, 0), _context18.stop());
                }
              }
            } finally {
              a00(150, 0);
            }
          }, _callee18, this));
        } finally {
          a00(149, 0);
        }
      })));
      function getApplicationProtections(_x46, _x47, _x48, _x49) {
        try {
          a00(151, 1);
          return a00(151, 2, a00(151, 0), _ref19.apply(this, arguments));
        } finally {
          a00(151, 0);
        }
      }
      return getApplicationProtections;
    } finally {
      a00(148, 0);
    }
  })()),
  getApplicationProtectionsCount: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(152, 1);
      var _ref20 = a00(152, 2, a00(152, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee19(client, applicationId, fragments) {
        try {
          a00(153, 1);
          var query;
          return a00(153, 2, a00(153, 0), regeneratorRuntime.wrap(function _callee19$(_context19) {
            try {
              a00(154, 1);
              while (1) {
                a00(154, -1);
                switch (_context19.prev = _context19.next) {
                  case 0:
                    _context19.next = 2;
                    return a00(154, 2, a00(154, 0), queries.getApplicationProtectionsCount(applicationId, fragments));
                  case 2:
                    query = _context19.sent;
                    return a00(154, 2, a00(154, 0), _context19.abrupt('return', client.get('/application', query)));
                  case 4:
                  case 'end':
                    return a00(154, 2, a00(154, 0), _context19.stop());
                }
              }
            } finally {
              a00(154, 0);
            }
          }, _callee19, this));
        } finally {
          a00(153, 0);
        }
      })));
      function getApplicationProtectionsCount(_x50, _x51, _x52) {
        try {
          a00(155, 1);
          return a00(155, 2, a00(155, 0), _ref20.apply(this, arguments));
        } finally {
          a00(155, 0);
        }
      }
      return getApplicationProtectionsCount;
    } finally {
      a00(152, 0);
    }
  })()),
  createTemplate: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(156, 1);
      var _ref21 = a00(156, 2, a00(156, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee20(client, template, fragments) {
        try {
          a00(157, 1);
          var mutation;
          return a00(157, 2, a00(157, 0), regeneratorRuntime.wrap(function _callee20$(_context20) {
            try {
              a00(158, 1);
              while (1) {
                a00(158, -1);
                switch (_context20.prev = _context20.next) {
                  case 0:
                    _context20.next = 2;
                    return a00(158, 2, a00(158, 0), mutations.createTemplate(template, fragments));
                  case 2:
                    mutation = _context20.sent;
                    return a00(158, 2, a00(158, 0), _context20.abrupt('return', client.post('/application', mutation)));
                  case 4:
                  case 'end':
                    return a00(158, 2, a00(158, 0), _context20.stop());
                }
              }
            } finally {
              a00(158, 0);
            }
          }, _callee20, this));
        } finally {
          a00(157, 0);
        }
      })));
      function createTemplate(_x53, _x54, _x55) {
        try {
          a00(159, 1);
          return a00(159, 2, a00(159, 0), _ref21.apply(this, arguments));
        } finally {
          a00(159, 0);
        }
      }
      return createTemplate;
    } finally {
      a00(156, 0);
    }
  })()),
  removeTemplate: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(160, 1);
      var _ref22 = a00(160, 2, a00(160, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee21(client, id) {
        try {
          a00(161, 1);
          var mutation;
          return a00(161, 2, a00(161, 0), regeneratorRuntime.wrap(function _callee21$(_context21) {
            try {
              a00(162, 1);
              while (1) {
                a00(162, -1);
                switch (_context21.prev = _context21.next) {
                  case 0:
                    _context21.next = 2;
                    return a00(162, 2, a00(162, 0), mutations.removeTemplate(id));
                  case 2:
                    mutation = _context21.sent;
                    return a00(162, 2, a00(162, 0), _context21.abrupt('return', client.post('/application', mutation)));
                  case 4:
                  case 'end':
                    return a00(162, 2, a00(162, 0), _context21.stop());
                }
              }
            } finally {
              a00(162, 0);
            }
          }, _callee21, this));
        } finally {
          a00(161, 0);
        }
      })));
      function removeTemplate(_x56, _x57) {
        try {
          a00(163, 1);
          return a00(163, 2, a00(163, 0), _ref22.apply(this, arguments));
        } finally {
          a00(163, 0);
        }
      }
      return removeTemplate;
    } finally {
      a00(160, 0);
    }
  })()),
  getTemplates: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(164, 1);
      var _ref23 = a00(164, 2, a00(164, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee22(client, fragments) {
        try {
          a00(165, 1);
          var query;
          return a00(165, 2, a00(165, 0), regeneratorRuntime.wrap(function _callee22$(_context22) {
            try {
              a00(166, 1);
              while (1) {
                a00(166, -1);
                switch (_context22.prev = _context22.next) {
                  case 0:
                    _context22.next = 2;
                    return a00(166, 2, a00(166, 0), queries.getTemplates(fragments));
                  case 2:
                    query = _context22.sent;
                    return a00(166, 2, a00(166, 0), _context22.abrupt('return', client.get('/application', query)));
                  case 4:
                  case 'end':
                    return a00(166, 2, a00(166, 0), _context22.stop());
                }
              }
            } finally {
              a00(166, 0);
            }
          }, _callee22, this));
        } finally {
          a00(165, 0);
        }
      })));
      function getTemplates(_x58, _x59) {
        try {
          a00(167, 1);
          return a00(167, 2, a00(167, 0), _ref23.apply(this, arguments));
        } finally {
          a00(167, 0);
        }
      }
      return getTemplates;
    } finally {
      a00(164, 0);
    }
  })()),
  getApplications: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(168, 1);
      var _ref24 = a00(168, 2, a00(168, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee23(client, fragments, params) {
        try {
          a00(169, 1);
          var query;
          return a00(169, 2, a00(169, 0), regeneratorRuntime.wrap(function _callee23$(_context23) {
            try {
              a00(170, 1);
              while (1) {
                a00(170, -1);
                switch (_context23.prev = _context23.next) {
                  case 0:
                    _context23.next = 2;
                    return a00(170, 2, a00(170, 0), queries.getApplications(fragments, params));
                  case 2:
                    query = _context23.sent;
                    return a00(170, 2, a00(170, 0), _context23.abrupt('return', client.get('/application', query)));
                  case 4:
                  case 'end':
                    return a00(170, 2, a00(170, 0), _context23.stop());
                }
              }
            } finally {
              a00(170, 0);
            }
          }, _callee23, this));
        } finally {
          a00(169, 0);
        }
      })));
      function getApplications(_x60, _x61, _x62) {
        try {
          a00(171, 1);
          return a00(171, 2, a00(171, 0), _ref24.apply(this, arguments));
        } finally {
          a00(171, 0);
        }
      }
      return getApplications;
    } finally {
      a00(168, 0);
    }
  })()),
  addApplicationSource: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(172, 1);
      var _ref25 = a00(172, 2, a00(172, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee24(client, applicationId, applicationSource, fragments) {
        try {
          a00(173, 1);
          var mutation;
          return a00(173, 2, a00(173, 0), regeneratorRuntime.wrap(function _callee24$(_context24) {
            try {
              a00(174, 1);
              while (1) {
                a00(174, -1);
                switch (_context24.prev = _context24.next) {
                  case 0:
                    _context24.next = 2;
                    return a00(174, 2, a00(174, 0), mutations.addApplicationSource(applicationId, applicationSource, fragments));
                  case 2:
                    mutation = _context24.sent;
                    return a00(174, 2, a00(174, 0), _context24.abrupt('return', client.post('/application', mutation)));
                  case 4:
                  case 'end':
                    return a00(174, 2, a00(174, 0), _context24.stop());
                }
              }
            } finally {
              a00(174, 0);
            }
          }, _callee24, this));
        } finally {
          a00(173, 0);
        }
      })));
      function addApplicationSource(_x63, _x64, _x65, _x66) {
        try {
          a00(175, 1);
          return a00(175, 2, a00(175, 0), _ref25.apply(this, arguments));
        } finally {
          a00(175, 0);
        }
      }
      return addApplicationSource;
    } finally {
      a00(172, 0);
    }
  })()),
  addApplicationSourceFromURL: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(176, 1);
      var _ref26 = a00(176, 2, a00(176, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee25(client, applicationId, url, fragments) {
        try {
          a00(177, 1);
          var file, mutation;
          return a00(177, 2, a00(177, 0), regeneratorRuntime.wrap(function _callee25$(_context25) {
            try {
              a00(178, 1);
              while (1) {
                a00(178, -1);
                switch (_context25.prev = _context25.next) {
                  case 0:
                    _context25.next = 2;
                    return a00(178, 2, a00(178, 0), getFileFromUrl(client, url));
                  case 2:
                    file = _context25.sent;
                    _context25.next = 5;
                    return a00(178, 2, a00(178, 0), mutations.addApplicationSource(applicationId, file, fragments));
                  case 5:
                    mutation = _context25.sent;
                    return a00(178, 2, a00(178, 0), _context25.abrupt('return', client.post('/application', mutation)));
                  case 7:
                  case 'end':
                    return a00(178, 2, a00(178, 0), _context25.stop());
                }
              }
            } finally {
              a00(178, 0);
            }
          }, _callee25, this));
        } finally {
          a00(177, 0);
        }
      })));
      function addApplicationSourceFromURL(_x67, _x68, _x69, _x70) {
        try {
          a00(179, 1);
          return a00(179, 2, a00(179, 0), _ref26.apply(this, arguments));
        } finally {
          a00(179, 0);
        }
      }
      return addApplicationSourceFromURL;
    } finally {
      a00(176, 0);
    }
  })()),
  updateApplicationSource: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(180, 1);
      var _ref27 = a00(180, 2, a00(180, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee26(client, applicationSource, fragments) {
        try {
          a00(181, 1);
          var mutation;
          return a00(181, 2, a00(181, 0), regeneratorRuntime.wrap(function _callee26$(_context26) {
            try {
              a00(182, 1);
              while (1) {
                a00(182, -1);
                switch (_context26.prev = _context26.next) {
                  case 0:
                    _context26.next = 2;
                    return a00(182, 2, a00(182, 0), mutations.updateApplicationSource(applicationSource, fragments));
                  case 2:
                    mutation = _context26.sent;
                    return a00(182, 2, a00(182, 0), _context26.abrupt('return', client.post('/application', mutation)));
                  case 4:
                  case 'end':
                    return a00(182, 2, a00(182, 0), _context26.stop());
                }
              }
            } finally {
              a00(182, 0);
            }
          }, _callee26, this));
        } finally {
          a00(181, 0);
        }
      })));
      function updateApplicationSource(_x71, _x72, _x73) {
        try {
          a00(183, 1);
          return a00(183, 2, a00(183, 0), _ref27.apply(this, arguments));
        } finally {
          a00(183, 0);
        }
      }
      return updateApplicationSource;
    } finally {
      a00(180, 0);
    }
  })()),
  removeSourceFromApplication: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(184, 1);
      var _ref28 = a00(184, 2, a00(184, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee27(client, sourceId, applicationId, fragments) {
        try {
          a00(185, 1);
          var mutation;
          return a00(185, 2, a00(185, 0), regeneratorRuntime.wrap(function _callee27$(_context27) {
            try {
              a00(186, 1);
              while (1) {
                a00(186, -1);
                switch (_context27.prev = _context27.next) {
                  case 0:
                    _context27.next = 2;
                    return a00(186, 2, a00(186, 0), mutations.removeSourceFromApplication(sourceId, applicationId, fragments));
                  case 2:
                    mutation = _context27.sent;
                    return a00(186, 2, a00(186, 0), _context27.abrupt('return', client.post('/application', mutation)));
                  case 4:
                  case 'end':
                    return a00(186, 2, a00(186, 0), _context27.stop());
                }
              }
            } finally {
              a00(186, 0);
            }
          }, _callee27, this));
        } finally {
          a00(185, 0);
        }
      })));
      function removeSourceFromApplication(_x74, _x75, _x76, _x77) {
        try {
          a00(187, 1);
          return a00(187, 2, a00(187, 0), _ref28.apply(this, arguments));
        } finally {
          a00(187, 0);
        }
      }
      return removeSourceFromApplication;
    } finally {
      a00(184, 0);
    }
  })()),
  applyTemplate: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(188, 1);
      var _ref29 = a00(188, 2, a00(188, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee28(client, templateId, appId, fragments) {
        try {
          a00(189, 1);
          var mutation;
          return a00(189, 2, a00(189, 0), regeneratorRuntime.wrap(function _callee28$(_context28) {
            try {
              a00(190, 1);
              while (1) {
                a00(190, -1);
                switch (_context28.prev = _context28.next) {
                  case 0:
                    _context28.next = 2;
                    return a00(190, 2, a00(190, 0), mutations.applyTemplate(templateId, appId, fragments));
                  case 2:
                    mutation = _context28.sent;
                    return a00(190, 2, a00(190, 0), _context28.abrupt('return', client.post('/application', mutation)));
                  case 4:
                  case 'end':
                    return a00(190, 2, a00(190, 0), _context28.stop());
                }
              }
            } finally {
              a00(190, 0);
            }
          }, _callee28, this));
        } finally {
          a00(189, 0);
        }
      })));
      function applyTemplate(_x78, _x79, _x80, _x81) {
        try {
          a00(191, 1);
          return a00(191, 2, a00(191, 0), _ref29.apply(this, arguments));
        } finally {
          a00(191, 0);
        }
      }
      return applyTemplate;
    } finally {
      a00(188, 0);
    }
  })()),
  updateTemplate: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(192, 1);
      var _ref30 = a00(192, 2, a00(192, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee29(client, template, fragments) {
        try {
          a00(193, 1);
          var mutation;
          return a00(193, 2, a00(193, 0), regeneratorRuntime.wrap(function _callee29$(_context29) {
            try {
              a00(194, 1);
              while (1) {
                a00(194, -1);
                switch (_context29.prev = _context29.next) {
                  case 0:
                    _context29.next = 2;
                    return a00(194, 2, a00(194, 0), mutations.updateTemplate(template, fragments));
                  case 2:
                    mutation = _context29.sent;
                    return a00(194, 2, a00(194, 0), _context29.abrupt('return', client.post('/application', mutation)));
                  case 4:
                  case 'end':
                    return a00(194, 2, a00(194, 0), _context29.stop());
                }
              }
            } finally {
              a00(194, 0);
            }
          }, _callee29, this));
        } finally {
          a00(193, 0);
        }
      })));
      function updateTemplate(_x82, _x83, _x84) {
        try {
          a00(195, 1);
          return a00(195, 2, a00(195, 0), _ref30.apply(this, arguments));
        } finally {
          a00(195, 0);
        }
      }
      return updateTemplate;
    } finally {
      a00(192, 0);
    }
  })()),
  startInstrumentation: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(196, 1);
      var _ref31 = a00(196, 2, a00(196, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee30(client, applicationId) {
        try {
          a00(197, 1);
          var instrumentation;
          return a00(197, 2, a00(197, 0), regeneratorRuntime.wrap(function _callee30$(_context30) {
            try {
              a00(198, 1);
              while (1) {
                a00(198, -1);
                switch (_context30.prev = _context30.next) {
                  case 0:
                    _context30.next = 2;
                    return a00(198, 2, a00(198, 0), a00(198, 2, a00(198, 0), client.get('/profiling-run', {
                      applicationId: applicationId
                    })).catch(function (e) {
                      try {
                        a00(199, 1);
                        if (e.statusCode !== 400) throw e;
                      } finally {
                        a00(199, 0);
                      }
                    }));
                  case 2:
                    instrumentation = _context30.sent;
                    if (!instrumentation) {
                      _context30.next = 6;
                      break;
                    }
                    _context30.next = 6;
                    return a00(198, 2, a00(198, 0), client.patch('/profiling-run/' + instrumentation.data.id, {
                      state: 'DELETED'
                    }));
                  case 6:
                    return a00(198, 2, a00(198, 0), _context30.abrupt('return', client.post('/profiling-run', {
                      applicationId: applicationId
                    })));
                  case 7:
                  case 'end':
                    return a00(198, 2, a00(198, 0), _context30.stop());
                }
              }
            } finally {
              a00(198, 0);
            }
          }, _callee30, this));
        } finally {
          a00(197, 0);
        }
      })));
      function startInstrumentation(_x85, _x86) {
        try {
          a00(200, 1);
          return a00(200, 2, a00(200, 0), _ref31.apply(this, arguments));
        } finally {
          a00(200, 0);
        }
      }
      return startInstrumentation;
    } finally {
      a00(196, 0);
    }
  })()),
  createApplicationProtection: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(201, 1);
      var _ref32 = a00(201, 2, a00(201, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee31(client, applicationId, protectionOptions, fragments) {
        try {
          a00(202, 1);
          var _ref33, args, mutation;
          return a00(202, 2, a00(202, 0), regeneratorRuntime.wrap(function _callee31$(_context31) {
            try {
              a00(203, 1);
              while (1) {
                a00(203, -1);
                switch (_context31.prev = _context31.next) {
                  case 0:
                    _context31.next = 2;
                    return a00(203, 2, a00(203, 0), introspection.mutation(client, 'createApplicationProtection'));
                  case 2:
                    _ref33 = _context31.sent;
                    args = _ref33.args;
                    _context31.next = 6;
                    return a00(203, 2, a00(203, 0), mutations.createApplicationProtection(applicationId, fragments, protectionOptions, args));
                  case 6:
                    mutation = _context31.sent;
                    return a00(203, 2, a00(203, 0), _context31.abrupt('return', client.post('/application', mutation)));
                  case 8:
                  case 'end':
                    return a00(203, 2, a00(203, 0), _context31.stop());
                }
              }
            } finally {
              a00(203, 0);
            }
          }, _callee31, this));
        } finally {
          a00(202, 0);
        }
      })));
      function createApplicationProtection(_x87, _x88, _x89, _x90) {
        try {
          a00(204, 1);
          return a00(204, 2, a00(204, 0), _ref32.apply(this, arguments));
        } finally {
          a00(204, 0);
        }
      }
      return createApplicationProtection;
    } finally {
      a00(201, 0);
    }
  })()),
  getInstrumentation: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(205, 1);
      var _ref34 = a00(205, 2, a00(205, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee32(client, instrumentationId) {
        try {
          a00(206, 1);
          return a00(206, 2, a00(206, 0), regeneratorRuntime.wrap(function _callee32$(_context32) {
            try {
              a00(207, 1);
              while (1) {
                a00(207, -1);
                switch (_context32.prev = _context32.next) {
                  case 0:
                    return a00(207, 2, a00(207, 0), _context32.abrupt('return', client.get('/profiling-run/' + instrumentationId)));
                  case 1:
                  case 'end':
                    return a00(207, 2, a00(207, 0), _context32.stop());
                }
              }
            } finally {
              a00(207, 0);
            }
          }, _callee32, this));
        } finally {
          a00(206, 0);
        }
      })));
      function getInstrumentation(_x91, _x92) {
        try {
          a00(208, 1);
          return a00(208, 2, a00(208, 0), _ref34.apply(this, arguments));
        } finally {
          a00(208, 0);
        }
      }
      return getInstrumentation;
    } finally {
      a00(205, 0);
    }
  })()),
  getApplicationProtection: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(209, 1);
      var _ref35 = a00(209, 2, a00(209, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee33(client, applicationId, protectionId, fragments) {
        try {
          a00(210, 1);
          var query;
          return a00(210, 2, a00(210, 0), regeneratorRuntime.wrap(function _callee33$(_context33) {
            try {
              a00(211, 1);
              while (1) {
                a00(211, -1);
                switch (_context33.prev = _context33.next) {
                  case 0:
                    _context33.next = 2;
                    return a00(211, 2, a00(211, 0), queries.getProtection(applicationId, protectionId, fragments));
                  case 2:
                    query = _context33.sent;
                    return a00(211, 2, a00(211, 0), _context33.abrupt('return', client.get('/application', query)));
                  case 4:
                  case 'end':
                    return a00(211, 2, a00(211, 0), _context33.stop());
                }
              }
            } finally {
              a00(211, 0);
            }
          }, _callee33, this));
        } finally {
          a00(210, 0);
        }
      })));
      function getApplicationProtection(_x93, _x94, _x95, _x96) {
        try {
          a00(212, 1);
          return a00(212, 2, a00(212, 0), _ref35.apply(this, arguments));
        } finally {
          a00(212, 0);
        }
      }
      return getApplicationProtection;
    } finally {
      a00(209, 0);
    }
  })()),
  downloadSourceMapsRequest: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(213, 1);
      var _ref36 = a00(213, 2, a00(213, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee34(client, protectionId) {
        try {
          a00(214, 1);
          return a00(214, 2, a00(214, 0), regeneratorRuntime.wrap(function _callee34$(_context34) {
            try {
              a00(215, 1);
              while (1) {
                a00(215, -1);
                switch (_context34.prev = _context34.next) {
                  case 0:
                    return a00(215, 2, a00(215, 0), _context34.abrupt('return', client.get('/application/sourceMaps/' + protectionId, null, false)));
                  case 1:
                  case 'end':
                    return a00(215, 2, a00(215, 0), _context34.stop());
                }
              }
            } finally {
              a00(215, 0);
            }
          }, _callee34, this));
        } finally {
          a00(214, 0);
        }
      })));
      function downloadSourceMapsRequest(_x97, _x98) {
        try {
          a00(216, 1);
          return a00(216, 2, a00(216, 0), _ref36.apply(this, arguments));
        } finally {
          a00(216, 0);
        }
      }
      return downloadSourceMapsRequest;
    } finally {
      a00(213, 0);
    }
  })()),
  downloadApplicationProtection: a00(57, 2, a00(57, 0), (function () {
    try {
      a00(217, 1);
      var _ref37 = a00(217, 2, a00(217, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee35(client, protectionId) {
        try {
          a00(218, 1);
          return a00(218, 2, a00(218, 0), regeneratorRuntime.wrap(function _callee35$(_context35) {
            try {
              a00(219, 1);
              while (1) {
                a00(219, -1);
                switch (_context35.prev = _context35.next) {
                  case 0:
                    return a00(219, 2, a00(219, 0), _context35.abrupt('return', client.get('/application/download/' + protectionId, null, false)));
                  case 1:
                  case 'end':
                    return a00(219, 2, a00(219, 0), _context35.stop());
                }
              }
            } finally {
              a00(219, 0);
            }
          }, _callee35, this));
        } finally {
          a00(218, 0);
        }
      })));
      function downloadApplicationProtection(_x99, _x100) {
        try {
          a00(220, 1);
          return a00(220, 2, a00(220, 0), _ref37.apply(this, arguments));
        } finally {
          a00(220, 0);
        }
      }
      return downloadApplicationProtection;
    } finally {
      a00(217, 0);
    }
  })()),
  downloadApplicationInstrumented: function downloadApplicationInstrumented(client, instrumentationId) {
    try {
      a00(221, 1);
      return a00(221, 2, a00(221, 0), client.get('/profiling-run/' + instrumentationId + '/instrumented-bundle', null, false));
    } finally {
      a00(221, 0);
    }
  }
};
function getFileFromUrl(client, url) {
  try {
    a00(222, 1);
    return a00(222, 2, a00(222, 0), a00(222, 2, a00(222, 0), _axios2.default.get(url)).then(function (res) {
      try {
        a00(223, 1);
        return {
          content: res.data,
          filename: a00(223, 2, a00(223, 0), _path2.default.basename(url)),
          extension: a00(223, 2, a00(223, 0), a00(223, 2, a00(223, 0), _path2.default.extname(url)).substr(1))
        };
      } finally {
        a00(223, 0);
      }
    }));
  } finally {
    a00(222, 0);
  }
}
a00(57, 0);