'use strict';
var a00 = (function (_global) {
  if (_global.a00) {
    return _global.a00;
  }
  var _now = _global.Date.now ? _global.Date.now : function () {
    return new _global.Date().getTime();
  };
  var xhr, http, a;
  var token = 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE1ODM4MzA2MTg5NjAzNjAwLCJ1c2VySWQiOiIxNyIsInByb2ZpbGluZ1J1bklkIjoiNWU2NzU2NWE2NzAxZTgwMDExYzIzNmUzIiwiaWF0IjoxNTgzODMwNjE4fQ.IElkPVIJmpvtIljriz770ACFsHARdLijjmgJth6Ua1g', path = '/p/profiling-data-point/2107a04479f9f1832a9fd5bb06e5eb716967aeee/5e67565a6701e80011c236e3', protocol = 'http', port = '8068', host = 'localhost', jscramblerVersion = 6.3;
  var reqErrorCounter = 0, shouldSend = false, setTimeoutRegistered = false, stopSendingData = false;
  var contentTypeKey = 'Content-Type', contentType = 'application/json', authorizationKey = 'Authorization', authorization = 'Bearer ' + token, jscramblerVersionKey = 'jscramblerVersion', method = 'POST';
  var headers = {};
  headers[contentTypeKey] = contentType;
  headers[authorizationKey] = authorization;
  headers[jscramblerVersionKey] = jscramblerVersion;
  var postOptions = {
    host: host,
    port: port,
    path: path,
    method: method,
    headers: headers
  };
  _global.XMLHttpRequest && (xhr = new _global.XMLHttpRequest()) || typeof require === typeof _global.Date && (a = require) && (http = a(protocol));
  function sendInfo(globalObject) {
    function clearErrorCounter() {
      reqErrorCounter = 0;
    }
    function errorHandler() {
      if (++reqErrorCounter >= 3) {
        stopSendingData = true;
        console.error('Limit of errored requests reached, stopping request service.');
      } else {
        registerSendTimer();
      }
    }
    function handleStatusCode(statusCode, statusMsg) {
      switch (statusCode) {
        case 200:
          clearErrorCounter();
          shouldSend = false;
          break;
        case 403:
          stopSendingData = true;
          break;
        case 424:
          stopSendingData = true;
          console.error('Make sure to "Start Profiling" on the web application before running the instrumented app.');
          break;
        default:
          errorHandler();
      }
    }
    function httpResponseHandler(response) {
      var statusCode = response.statusCode;
      var statusMessage = response.statusMessage;
      handleStatusCode(statusCode, statusMessage);
    }
    function compatibilityReqHandler() {
      if (xhr.readyState === 4) {
        handleStatusCode(xhr.status, xhr.responseText);
      }
    }
    function sendRequest(data) {
      data.sessionMetadata['timestamp'] = _now();
      if (xhr) {
        xhr.onreadystatechange = compatibilityReqHandler;
        xhr.open(method, protocol + '://' + host + ':' + port + path, true);
        xhr.setRequestHeader(authorizationKey, authorization);
        xhr.setRequestHeader(contentTypeKey, contentType);
        xhr.setRequestHeader(jscramblerVersionKey, jscramblerVersion);
        xhr.send(JSON.stringify(data));
      } else if (http) {
        var req = http.request(postOptions, httpResponseHandler);
        req.write(JSON.stringify(data));
        req.end();
        req.on('error', function (err) {
          var errorMsg = 'Failed to contact profiling service! Error message: ' + err.message;
          errorHandler();
        });
      } else {
        console.log('Error: Supported network request API interfaces (xhr, http) are not available in this context! Please contact the support.');
      }
    }
    ;
    if (!stopSendingData) {
      sendRequest(reportObj);
    }
  }
  ;
  var reportObj = {
    sessionMetadata: {
      sessionId: _now(),
      platform: _global.process && _global.process.platform ? _global.process.platform : _global.navigator && _global.navigator.platform,
      userAgent: _global.navigator && _global.navigator.userAgent,
      location: _global.location && _global.location.href,
      nodeVersion: _global.process && _global.process.version,
      product: _global.navigator && _global.navigator.product || (_global.android ? 'NativeScript/android' : undefined)
    },
    data: {}
  };
  var lastRecord = {
    s: 0
  };
  function registerSendTimer() {
    setTimeoutRegistered = true;
    setTimeout(function () {
      setTimeoutRegistered = false;
      return sendInfo(_global);
    }, 2500);
  }
  function record(name, type, stopFn, fn) {
    if (type === -1) {
      reportObj.data[name][2] += 1;
      return fn;
    }
    var t = _now();
    shouldSend = true;
    if (reportObj.data[name] === undefined) {
      reportObj.data[name] = [0, 0, 0];
    }
    if (shouldSend && !setTimeoutRegistered && !stopSendingData) {
      registerSendTimer();
    }
    if (type === 1) {
      reportObj.data[name][0] += 1;
    }
    if (lastRecord.s === 0) {
      lastRecord = {
        f: name,
        s: type,
        t: t
      };
      return fn;
    }
    reportObj.data[lastRecord.f][1] += t - lastRecord.t;
    lastRecord = {
      f: name,
      s: type,
      t: _now()
    };
    return fn;
  }
  ;
  ;
  _global.a00 = record;
  return _global.a00;
})(global);
a00(224, 1);
a00(224, 2, a00(224, 0), Object.defineProperty(exports, "__esModule", {
  value: true
}));
exports.intoObjectType = exports.mutation = exports.type = undefined;
var type = exports.type = a00(224, 2, a00(224, 0), (function () {
  try {
    a00(225, 1);
    var _ref = a00(225, 2, a00(225, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee(client, name) {
      try {
        a00(226, 1);
        var jscramblerVersion, query, res, __type;
        return a00(226, 2, a00(226, 0), regeneratorRuntime.wrap(function _callee$(_context) {
          try {
            a00(227, 1);
            while (1) {
              a00(227, -1);
              switch (_context.prev = _context.next) {
                case 0:
                  jscramblerVersion = client.options.jscramblerVersion;
                  if (!typeCache[jscramblerVersion]) {
                    typeCache[jscramblerVersion] = {};
                  }
                  if (!typeCache[jscramblerVersion][name]) {
                    _context.next = 4;
                    break;
                  }
                  return a00(227, 2, a00(227, 0), _context.abrupt('return', typeCache[jscramblerVersion][name]));
                case 4:
                  query = {
                    query: '\nquery getType($name: String!) {\n  __type(name: $name) {\n    kind\n    name\n    description\n    fields(includeDeprecated: true) {\n      name\n      description\n      args {\n        ...InputValue\n      }\n      type {\n        ...TypeRef\n      }\n      isDeprecated\n      deprecationReason\n    }\n    inputFields {\n      ...InputValue\n    }\n    interfaces {\n      ...TypeRef\n    }\n    enumValues(includeDeprecated: true) {\n      name\n      description\n      isDeprecated\n      deprecationReason\n    }\n    possibleTypes {\n      ...TypeRef\n    }\n  }\n}\n\nfragment InputValue on __InputValue {\n  name\n  description\n  type { ...TypeRef }\n  defaultValue\n}\n\nfragment TypeRef on __Type {\n  kind\n  name\n  inputFields {\n    name\n    type {\n      name\n      kind\n    }\n  }\n  ofType {\n    kind\n    name\n    ofType {\n      kind\n      name\n      ofType {\n        kind\n        name\n      }\n    }\n  }\n}',
                    params: a00(227, 2, a00(227, 0), JSON.stringify({
                      name: name
                    }))
                  };
                  _context.next = 7;
                  return a00(227, 2, a00(227, 0), client.get('/application', query));
                case 7:
                  res = _context.sent;
                  __type = res.data.__type;
                  typeCache[jscramblerVersion][__type.name] = __type;
                  return a00(227, 2, a00(227, 0), _context.abrupt('return', __type));
                case 11:
                case 'end':
                  return a00(227, 2, a00(227, 0), _context.stop());
              }
            }
          } finally {
            a00(227, 0);
          }
        }, _callee, this));
      } finally {
        a00(226, 0);
      }
    })));
    return function type(_x, _x2) {
      try {
        a00(228, 1);
        return a00(228, 2, a00(228, 0), _ref.apply(this, arguments));
      } finally {
        a00(228, 0);
      }
    };
  } finally {
    a00(225, 0);
  }
})());
var mutation = exports.mutation = a00(224, 2, a00(224, 0), (function () {
  try {
    a00(229, 1);
    var _ref2 = a00(229, 2, a00(229, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee2(client, name) {
      try {
        a00(230, 1);
        var rootMutation, mutationType;
        return a00(230, 2, a00(230, 0), regeneratorRuntime.wrap(function _callee2$(_context2) {
          try {
            a00(231, 1);
            while (1) {
              a00(231, -1);
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.next = 2;
                  return a00(231, 2, a00(231, 0), type(client, 'RootMutation'));
                case 2:
                  rootMutation = _context2.sent;
                  mutationType = a00(231, 2, a00(231, 0), rootMutation.fields.find(function (f) {
                    try {
                      a00(232, 1);
                      return f.name === name;
                    } finally {
                      a00(232, 0);
                    }
                  }));
                  return a00(231, 2, a00(231, 0), _context2.abrupt('return', mutationType));
                case 5:
                case 'end':
                  return a00(231, 2, a00(231, 0), _context2.stop());
              }
            }
          } finally {
            a00(231, 0);
          }
        }, _callee2, this));
      } finally {
        a00(230, 0);
      }
    })));
    return function mutation(_x3, _x4) {
      try {
        a00(233, 1);
        return a00(233, 2, a00(233, 0), _ref2.apply(this, arguments));
      } finally {
        a00(233, 0);
      }
    };
  } finally {
    a00(229, 0);
  }
})());
var intoObjectType = exports.intoObjectType = a00(224, 2, a00(224, 0), (function () {
  try {
    a00(234, 1);
    var _ref3 = a00(234, 2, a00(234, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee4(client, obj, name) {
      try {
        a00(235, 1);
        var _this = this;
        var fields, finalObj, keys;
        return a00(235, 2, a00(235, 0), regeneratorRuntime.wrap(function _callee4$(_context4) {
          try {
            a00(236, 1);
            while (1) {
              a00(236, -1);
              switch (_context4.prev = _context4.next) {
                case 0:
                  _context4.next = 2;
                  return a00(236, 2, a00(236, 0), type(client, name));
                case 2:
                  fields = _context4.sent.fields;
                  finalObj = {};
                  keys = a00(236, 2, a00(236, 0), Object.keys(obj));
                  _context4.next = 7;
                  return a00(236, 2, a00(236, 0), Promise.all(keys.map((function () {
                    try {
                      a00(237, 1);
                      var _ref4 = a00(237, 2, a00(237, 0), _asyncToGenerator(regeneratorRuntime.mark(function _callee3(k) {
                        try {
                          a00(238, 1);
                          var field;
                          return a00(238, 2, a00(238, 0), regeneratorRuntime.wrap(function _callee3$(_context3) {
                            try {
                              a00(239, 1);
                              while (1) {
                                a00(239, -1);
                                switch (_context3.prev = _context3.next) {
                                  case 0:
                                    field = a00(239, 2, a00(239, 0), fields.find(function (f) {
                                      try {
                                        a00(240, 1);
                                        return f.name === k;
                                      } finally {
                                        a00(240, 0);
                                      }
                                    }));
                                    if (!(field && field.type)) {
                                      _context3.next = 14;
                                      break;
                                    }
                                    finalObj[k] = a00(239, 2, a00(239, 0), (0, _lodash2.default)(obj[k]));
                                    if (!(field.type.kind === 'OBJECT' && ! !field.type.name)) {
                                      _context3.next = 8;
                                      break;
                                    }
                                    _context3.next = 6;
                                    return a00(239, 2, a00(239, 0), intoObjectType(client, finalObj[k], field.type.name));
                                  case 6:
                                    finalObj[k] = _context3.sent;
                                    return a00(239, 2, a00(239, 0), _context3.abrupt('return'));
                                  case 8:
                                    if (!((field.type.kind === 'NON_NULL' || field.type.kind === 'LIST') && field.type.ofType.kind === 'OBJECT')) {
                                      _context3.next = 13;
                                      break;
                                    }
                                    _context3.next = 11;
                                    return a00(239, 2, a00(239, 0), intoObjectType(client, finalObj[k], field.type.ofType.name));
                                  case 11:
                                    finalObj[k] = _context3.sent;
                                    return a00(239, 2, a00(239, 0), _context3.abrupt('return'));
                                  case 13:
                                    if (field.type.name === 'String' && typeof finalObj[k] !== 'string') {
                                      finalObj[k] = a00(239, 2, a00(239, 0), JSON.stringify(finalObj[k]));
                                    }
                                  case 14:
                                  case 'end':
                                    return a00(239, 2, a00(239, 0), _context3.stop());
                                }
                              }
                            } finally {
                              a00(239, 0);
                            }
                          }, _callee3, _this));
                        } finally {
                          a00(238, 0);
                        }
                      })));
                      return function (_x8) {
                        try {
                          a00(241, 1);
                          return a00(241, 2, a00(241, 0), _ref4.apply(this, arguments));
                        } finally {
                          a00(241, 0);
                        }
                      };
                    } finally {
                      a00(237, 0);
                    }
                  })())));
                case 7:
                  return a00(236, 2, a00(236, 0), _context4.abrupt('return', finalObj));
                case 8:
                case 'end':
                  return a00(236, 2, a00(236, 0), _context4.stop());
              }
            }
          } finally {
            a00(236, 0);
          }
        }, _callee4, this));
      } finally {
        a00(235, 0);
      }
    })));
    return function intoObjectType(_x5, _x6, _x7) {
      try {
        a00(242, 1);
        return a00(242, 2, a00(242, 0), _ref3.apply(this, arguments));
      } finally {
        a00(242, 0);
      }
    };
  } finally {
    a00(234, 0);
  }
})());
var _lodash = require('lodash.clonedeep');
var _lodash2 = a00(224, 2, a00(224, 0), _interopRequireDefault(_lodash));
function _interopRequireDefault(obj) {
  try {
    a00(243, 1);
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  } finally {
    a00(243, 0);
  }
}
function _asyncToGenerator(fn) {
  try {
    a00(244, 1);
    return function () {
      try {
        a00(245, 1);
        var gen = a00(245, 2, a00(245, 0), fn.apply(this, arguments));
        return new Promise(function (resolve, reject) {
          try {
            a00(246, 1);
            function step(key, arg) {
              try {
                a00(247, 1);
                try {
                  var info = a00(247, 2, a00(247, 0), gen[key](arg));
                  var value = info.value;
                } catch (error) {
                  a00(247, 2, a00(247, 0), reject(error));
                  return;
                }
                if (info.done) {
                  a00(247, 2, a00(247, 0), resolve(value));
                } else {
                  return a00(247, 2, a00(247, 0), a00(247, 2, a00(247, 0), Promise.resolve(value)).then(function (value) {
                    try {
                      a00(248, 1);
                      a00(248, 2, a00(248, 0), step("next", value));
                    } finally {
                      a00(248, 0);
                    }
                  }, function (err) {
                    try {
                      a00(249, 1);
                      a00(249, 2, a00(249, 0), step("throw", err));
                    } finally {
                      a00(249, 0);
                    }
                  }));
                }
              } finally {
                a00(247, 0);
              }
            }
            return a00(246, 2, a00(246, 0), step("next"));
          } finally {
            a00(246, 0);
          }
        });
      } finally {
        a00(245, 0);
      }
    };
  } finally {
    a00(244, 0);
  }
}
var typeCache = {};
a00(224, 0);