'use strict';
var a00 = (function (_global) {
  if (_global.a00) {
    return _global.a00;
  }
  var _now = _global.Date.now ? _global.Date.now : function () {
    return new _global.Date().getTime();
  };
  var xhr, http, a;
  var token = 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE1ODM4MzA2MTg5NjAzNjAwLCJ1c2VySWQiOiIxNyIsInByb2ZpbGluZ1J1bklkIjoiNWU2NzU2NWE2NzAxZTgwMDExYzIzNmUzIiwiaWF0IjoxNTgzODMwNjE4fQ.IElkPVIJmpvtIljriz770ACFsHARdLijjmgJth6Ua1g', path = '/p/profiling-data-point/2107a04479f9f1832a9fd5bb06e5eb716967aeee/5e67565a6701e80011c236e3', protocol = 'http', port = '8068', host = 'localhost', jscramblerVersion = 6.3;
  var reqErrorCounter = 0, shouldSend = false, setTimeoutRegistered = false, stopSendingData = false;
  var contentTypeKey = 'Content-Type', contentType = 'application/json', authorizationKey = 'Authorization', authorization = 'Bearer ' + token, jscramblerVersionKey = 'jscramblerVersion', method = 'POST';
  var headers = {};
  headers[contentTypeKey] = contentType;
  headers[authorizationKey] = authorization;
  headers[jscramblerVersionKey] = jscramblerVersion;
  var postOptions = {
    host: host,
    port: port,
    path: path,
    method: method,
    headers: headers
  };
  _global.XMLHttpRequest && (xhr = new _global.XMLHttpRequest()) || typeof require === typeof _global.Date && (a = require) && (http = a(protocol));
  function sendInfo(globalObject) {
    function clearErrorCounter() {
      reqErrorCounter = 0;
    }
    function errorHandler() {
      if (++reqErrorCounter >= 3) {
        stopSendingData = true;
        console.error('Limit of errored requests reached, stopping request service.');
      } else {
        registerSendTimer();
      }
    }
    function handleStatusCode(statusCode, statusMsg) {
      switch (statusCode) {
        case 200:
          clearErrorCounter();
          shouldSend = false;
          break;
        case 403:
          stopSendingData = true;
          break;
        case 424:
          stopSendingData = true;
          console.error('Make sure to "Start Profiling" on the web application before running the instrumented app.');
          break;
        default:
          errorHandler();
      }
    }
    function httpResponseHandler(response) {
      var statusCode = response.statusCode;
      var statusMessage = response.statusMessage;
      handleStatusCode(statusCode, statusMessage);
    }
    function compatibilityReqHandler() {
      if (xhr.readyState === 4) {
        handleStatusCode(xhr.status, xhr.responseText);
      }
    }
    function sendRequest(data) {
      data.sessionMetadata['timestamp'] = _now();
      if (xhr) {
        xhr.onreadystatechange = compatibilityReqHandler;
        xhr.open(method, protocol + '://' + host + ':' + port + path, true);
        xhr.setRequestHeader(authorizationKey, authorization);
        xhr.setRequestHeader(contentTypeKey, contentType);
        xhr.setRequestHeader(jscramblerVersionKey, jscramblerVersion);
        xhr.send(JSON.stringify(data));
      } else if (http) {
        var req = http.request(postOptions, httpResponseHandler);
        req.write(JSON.stringify(data));
        req.end();
        req.on('error', function (err) {
          var errorMsg = 'Failed to contact profiling service! Error message: ' + err.message;
          errorHandler();
        });
      } else {
        console.log('Error: Supported network request API interfaces (xhr, http) are not available in this context! Please contact the support.');
      }
    }
    ;
    if (!stopSendingData) {
      sendRequest(reportObj);
    }
  }
  ;
  var reportObj = {
    sessionMetadata: {
      sessionId: _now(),
      platform: _global.process && _global.process.platform ? _global.process.platform : _global.navigator && _global.navigator.platform,
      userAgent: _global.navigator && _global.navigator.userAgent,
      location: _global.location && _global.location.href,
      nodeVersion: _global.process && _global.process.version,
      product: _global.navigator && _global.navigator.product || (_global.android ? 'NativeScript/android' : undefined)
    },
    data: {}
  };
  var lastRecord = {
    s: 0
  };
  function registerSendTimer() {
    setTimeoutRegistered = true;
    setTimeout(function () {
      setTimeoutRegistered = false;
      return sendInfo(_global);
    }, 2500);
  }
  function record(name, type, stopFn, fn) {
    if (type === -1) {
      reportObj.data[name][2] += 1;
      return fn;
    }
    var t = _now();
    shouldSend = true;
    if (reportObj.data[name] === undefined) {
      reportObj.data[name] = [0, 0, 0];
    }
    if (shouldSend && !setTimeoutRegistered && !stopSendingData) {
      registerSendTimer();
    }
    if (type === 1) {
      reportObj.data[name][0] += 1;
    }
    if (lastRecord.s === 0) {
      lastRecord = {
        f: name,
        s: type,
        t: t
      };
      return fn;
    }
    reportObj.data[lastRecord.f][1] += t - lastRecord.t;
    lastRecord = {
      f: name,
      s: type,
      t: _now()
    };
    return fn;
  }
  ;
  ;
  _global.a00 = record;
  return _global.a00;
})((function () {
  var A = 2;
  for (; A !== 9;) {
    switch (A) {
      case 1:
        return globalThis;
        break;
      case 2:
        A = typeof globalThis === '\u006f\x62\u006a\u0065\x63\u0074' ? 1 : 5;
        break;
      case 5:
        var _global;
        try {
          var P = 2;
          for (; P !== 4;) {
            switch (P) {
              case 2:
                Object['\u0064\u0065\u0066\x69\u006e\u0065\x50\u0072\u006f\u0070\x65\x72\x74\x79'](Object['\u0070\u0072\u006f\x74\x6f\u0074\x79\x70\u0065'], '\x67\u005f\u004f\x79\u0051', {
                  '\x67\x65\x74': function () {
                    var K = 2;
                    for (; K !== 1;) {
                      switch (K) {
                        case 2:
                          return this;
                          break;
                      }
                    }
                  },
                  '\x63\x6f\x6e\x66\x69\x67\x75\x72\x61\x62\x6c\x65': true
                });
                _global = g_OyQ;
                delete Object['\x70\u0072\u006f\u0074\x6f\x74\u0079\u0070\x65']['\u0067\u005f\u004f\u0079\x51'];
                P = 4;
                break;
            }
          }
        } catch (e) {
          _global = window;
        }
        return _global;
        break;
    }
  }
})());
a00(250, 1);
a00(250, 2, a00(250, 0), Object.defineProperty(exports, "__esModule", {
  value: true
}));
var _slicedToArray = a00(250, 2, a00(250, 0), (function () {
  try {
    a00(251, 1);
    function sliceIterator(arr, i) {
      try {
        a00(252, 1);
        var _arr = [];
        var _n = true;
        var _d = false;
        var _e = undefined;
        try {
          for (var _i = a00(252, 2, a00(252, 0), arr[Symbol.iterator]()), _s; !(_n = (_s = a00(252, 2, a00(252, 0), _i.next())).done); _n = true) {
            a00(252, -1);
            a00(252, 2, a00(252, 0), _arr.push(_s.value));
            if (i && _arr.length === i) break;
          }
        } catch (err) {
          _d = true;
          _e = err;
        } finally {
          try {
            if (!_n && _i["return"]) a00(252, 2, a00(252, 0), _i["return"]());
          } finally {
            if (_d) throw _e;
          }
        }
        return _arr;
      } finally {
        a00(252, 0);
      }
    }
    return function (arr, i) {
      try {
        a00(253, 1);
        if (a00(253, 2, a00(253, 0), Array.isArray(arr))) {
          return arr;
        } else if ((Symbol.iterator in a00(253, 2, a00(253, 0), Object(arr)))) {
          return a00(253, 2, a00(253, 0), sliceIterator(arr, i));
        } else {
          throw new TypeError("Invalid attempt to destructure non-iterable instance");
        }
      } finally {
        a00(253, 0);
      }
    };
  } finally {
    a00(251, 0);
  }
})());
exports.createApplication = createApplication;
exports.duplicateApplication = duplicateApplication;
exports.removeApplication = removeApplication;
exports.removeProtection = removeProtection;
exports.cancelProtection = cancelProtection;
exports.updateApplication = updateApplication;
exports.unlockApplication = unlockApplication;
exports.addApplicationSource = addApplicationSource;
exports.updateApplicationSource = updateApplicationSource;
exports.removeSourceFromApplication = removeSourceFromApplication;
exports.createTemplate = createTemplate;
exports.removeTemplate = removeTemplate;
exports.updateTemplate = updateTemplate;
exports.createApplicationProtection = createApplicationProtection;
exports.applyTemplate = applyTemplate;
var _cleanupInputFields3 = require('./cleanup-input-fields');
var _cleanupInputFields4 = a00(250, 2, a00(250, 0), _interopRequireDefault(_cleanupInputFields3));
function _interopRequireDefault(obj) {
  try {
    a00(254, 1);
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  } finally {
    a00(254, 0);
  }
}
var createApplicationDefaultFragments = '\n  _id,\n  createdAt,\n  name\n';
function createApplication(data) {
  try {
    a00(255, 1);
    var fragments = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : createApplicationDefaultFragments;
    return {
      query: '\n      mutation createApplication ($data: ApplicationCreate!) {\n        createApplication(data: $data) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: {
        data: data
      }
    };
  } finally {
    a00(255, 0);
  }
}
var duplicateApplicationDefaultFragments = '\n  _id\n';
function duplicateApplication(id) {
  try {
    a00(256, 1);
    var fragments = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : duplicateApplicationDefaultFragments;
    return {
      query: '\n      mutation duplicateApplication ($_id: String!) {\n        duplicateApplication (_id: $_id) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: {
        _id: id
      }
    };
  } finally {
    a00(256, 0);
  }
}
var removeApplicationDefaultFragments = '\n  _id\n';
function removeApplication(id) {
  try {
    a00(257, 1);
    var fragments = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : removeApplicationDefaultFragments;
    return {
      query: '\n      mutation removeApplication ($_id: String!) {\n        removeApplication (_id: $_id) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: {
        _id: id
      }
    };
  } finally {
    a00(257, 0);
  }
}
var removeProtectionDefaultFragments = '\n  _id\n';
function removeProtection(id, appId) {
  try {
    a00(258, 1);
    var fragments = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : removeProtectionDefaultFragments;
    return {
      query: '\n      mutation removeProtection ($_id: String!, $applicationId: String!) {\n        removeProtection (_id: $_id, applicationId: $applicationId) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: {
        _id: id,
        applicationId: appId
      }
    };
  } finally {
    a00(258, 0);
  }
}
var cancelProtectionDefaultFragments = '\n  _id\n';
function cancelProtection(id, appId) {
  try {
    a00(259, 1);
    var fragments = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : cancelProtectionDefaultFragments;
    return {
      query: '\n      mutation cancelProtection ($_id: String!, $applicationId: String!) {\n        cancelProtection (_id: $_id, applicationId: $applicationId) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: {
        _id: id,
        applicationId: appId
      }
    };
  } finally {
    a00(259, 0);
  }
}
var updateApplicationDefaultFragments = '\n  _id,\n  createdAt,\n  name\n';
function updateApplication(application) {
  try {
    a00(260, 1);
    var fragments = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : updateApplicationDefaultFragments;
    var applicationId = application._id;
    delete application._id;
    return {
      query: '\n      mutation updateApplication ($applicationId: String!, $data: ApplicationUpdate!) {\n        updateApplication (_id: $applicationId, data: $data) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: {
        applicationId: applicationId,
        data: application
      }
    };
  } finally {
    a00(260, 0);
  }
}
var unlockApplicationDefaultFragments = '\n  _id,\n  createdAt,\n  name\n';
function unlockApplication(application) {
  try {
    a00(261, 1);
    var fragments = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : unlockApplicationDefaultFragments;
    return {
      query: '\n      mutation unlockApplication ($applicationId: String!) {\n        unlockApplication (_id: $applicationId) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: {
        applicationId: application._id
      }
    };
  } finally {
    a00(261, 0);
  }
}
var addApplicationSourceDefaultFragments = '\n  _id,\n  filename,\n  extension\n';
function addApplicationSource(applicationId, data) {
  try {
    a00(262, 1);
    var fragments = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : addApplicationSourceDefaultFragments;
    return {
      query: '\n      mutation addSourceToApplication ($applicationId: String!, $data: ApplicationSourceCreate!) {\n        addSourceToApplication(applicationId: $applicationId, data: $data) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: {
        applicationId: applicationId,
        data: data
      }
    };
  } finally {
    a00(262, 0);
  }
}
var updateApplicationSourceDefaultFragments = '\n  _id,\n  filename,\n  extension\n';
function updateApplicationSource(applicationSource) {
  try {
    a00(263, 1);
    var fragments = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : updateApplicationSourceDefaultFragments;
    var sourceId = applicationSource._id;
    delete applicationSource._id;
    return {
      query: '\n      mutation updateApplicationSource ($sourceId: String!, $data: ApplicationSourceUpdate!) {\n        updateApplicationSource(_id: $sourceId, data: $data) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: {
        sourceId: sourceId,
        data: applicationSource
      }
    };
  } finally {
    a00(263, 0);
  }
}
var removeSourceFromApplicationDefaultFragments = '\n  _id,\n  sources {\n    filename\n  }\n';
function removeSourceFromApplication(filename, applicationId) {
  try {
    a00(264, 1);
    var fragments = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : removeSourceFromApplicationDefaultFragments;
    return {
      query: '\n      mutation removeSource ($filename: String!, $applicationId: String!) {\n        removeSource (filename: $filename, applicationId: $applicationId) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: {
        filename: filename,
        applicationId: applicationId
      }
    };
  } finally {
    a00(264, 0);
  }
}
var createTemplateDefaultFragments = '\n  _id,\n  name,\n  description,\n  parameters\n';
function createTemplate(template) {
  try {
    a00(265, 1);
    var fragments = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : createTemplateDefaultFragments;
    return {
      query: '\n      mutation createTemplate ($data: TemplateInput!) {\n        createTemplate (data: $data) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: {
        data: template
      }
    };
  } finally {
    a00(265, 0);
  }
}
var removeTemplateDefaultFragments = '\n  _id\n';
function removeTemplate(id) {
  try {
    a00(266, 1);
    var fragments = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : removeTemplateDefaultFragments;
    return {
      query: '\n      mutation removeTemplate ($_id: String!) {\n        removeTemplate (_id: $_id) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: {
        _id: id
      }
    };
  } finally {
    a00(266, 0);
  }
}
var updateTemplateDefaultFragments = '\n  _id,\n  parameters\n';
function updateTemplate(template) {
  try {
    a00(267, 1);
    var fragments = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : updateTemplateDefaultFragments;
    var templateId = template._id;
    delete template._id;
    return {
      query: '\n      mutation updateTemplate ($templateId: ID!, $data: TemplateInput!) {\n        updateTemplate (_id: $templateId, data: $data) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: {
        templateId: templateId,
        data: template
      }
    };
  } finally {
    a00(267, 0);
  }
}
var createProtectionDefaultFragments = '\n  _id,\n  state\n';
function createApplicationProtection(applicationId) {
  try {
    a00(268, 1);
    var _fragments = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : createProtectionDefaultFragments;
    var _options = arguments[2];
    var args = arguments[3];
    var fragments = _fragments;
    var options = _options;
    var _cleanupInputFields = a00(268, 2, a00(268, 0), (0, _cleanupInputFields4.default)(args, fragments, options));
    var _cleanupInputFields2 = a00(268, 2, a00(268, 0), _slicedToArray(_cleanupInputFields, 2));
    options = _cleanupInputFields2[0];
    fragments = _cleanupInputFields2[1];
    if (!a00(268, 2, a00(268, 0), args.some(function (f) {
      try {
        a00(269, 1);
        return f.name === 'options';
      } finally {
        a00(269, 0);
      }
    }))) {
      var _options2 = options, bail = _options2.bail, randomizationSeed = _options2.randomizationSeed;
      return {
        query: '\n      mutation createApplicationProtection ($applicationId: String!, $bail: Boolean, $randomizationSeed: String) {\n        createApplicationProtection (applicationId: $applicationId, bail: $bail, randomizationSeed: $randomizationSeed) {\n          ' + fragments + '\n        }\n      }\n    ',
        params: {
          applicationId: applicationId,
          bail: bail,
          randomizationSeed: randomizationSeed
        }
      };
    }
    if (a00(268, 2, a00(268, 0), args.some(function (arg) {
      try {
        a00(270, 1);
        return arg.name === 'data';
      } finally {
        a00(270, 0);
      }
    }))) {
      return {
        query: '\n        mutation createApplicationProtection ($applicationId: String!, $data: ApplicationProtectionCreate) {\n          createApplicationProtection (applicationId: $applicationId, data: $data) {\n            ' + fragments + '\n          }\n        }\n      ',
        params: {
          applicationId: applicationId,
          data: options
        }
      };
    }
    return {
      query: '\n      mutation createApplicationProtection ($applicationId: String!, $options: JSON) {\n        createApplicationProtection (applicationId: $applicationId, options: $options) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: {
        applicationId: applicationId,
        options: options
      }
    };
  } finally {
    a00(268, 0);
  }
}
var applyTemplateDefaultFragments = '\n  _id,\n  parameters\n';
function applyTemplate(templateId, appId) {
  try {
    a00(271, 1);
    var fragments = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : applyTemplateDefaultFragments;
    return {
      query: '\n      mutation applyTemplate ($templateId: String!, $appId: String!) {\n        applyTemplate (templateId: $templateId, appId: $appId) {\n          ' + fragments + '\n        }\n      }\n    ',
      params: {
        templateId: templateId,
        appId: appId
      }
    };
  } finally {
    a00(271, 0);
  }
}
a00(250, 0);